<?php
/**
 * @copyright    Copyright (C) 2009-2018 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingDtregister extends JPlugin{
	var $multipleTypes = array(1, 3, 4);

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'dtregister');
			$this->params = new acyParameter($plugin->params);
		}
	}

	function acymailing_getPluginType(){
		if($this->params->get('frontendaccess') == 'none' AND !acymailing_isAdmin()) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'DT Register';
		$onePlugin->function = 'acymailingdtregister_show';
		$onePlugin->help = 'plugin-dtregister';
		return $onePlugin;
	}

	function acymailingdtregister_show(){

		$config = acymailing_config();
		if(version_compare($config->get('version'), '5.0.1', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		
		acymailing_loadLanguageFile('com_dtregister', JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.dtregister';
		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.slabId', 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->titlelink = acymailing_getUserVar($paramBase.".titlelink", 'titlelink', 'link', 'string');
		$pageInfo->register = acymailing_getUserVar($paramBase.".register", 'register', '0', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->contenttype = acymailing_getUserVar($paramBase.".contenttype", 'contenttype', 'intro', 'string');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->autotitlelink = acymailing_getUserVar($paramBase.".autotitlelink", 'autotitlelink', 'link', 'string');
		$pageInfo->autopict = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->automaxvalue = acymailing_getUserVar($paramBase.".max", 'max', '20', 'int');
		$pageInfo->autoregister = acymailing_getUserVar($paramBase.".register", 'register', '0', 'string');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', '|filter:created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', '|order:dtstart,ASC', 'string');
		$pageInfo->autocontenttype = acymailing_getUserVar($paramBase.".autocontenttype", 'autocontenttype', 'intro', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');

		$searchFields = array('a.slabId', 'a.title', 'b.categoryName', 'a.dtstart');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.publish = 1";
		}else{
			$filters[] = "a.publish != -2";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.* ';
		$query .= 'FROM #__dtregister_group_event as a';
		$query .= ' LEFT JOIN `#__dtregister_categories` as b ON a.category = b.categoryId';
		if(!empty($pageInfo->filter_cat)) $filters[] = "a.category = ".$pageInfo->filter_cat;

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += '|type:' + document.adminForm.contenttype[i].value;
					}
				}
				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pict.length; i++){
						if(document.adminForm.pict[i].checked){
							otherinfo += '|pict:' + document.adminForm.pict[i].value;
							if(document.adminForm.pict[i].value == 'resized'){
								document.getElementById('pictsize').style.display = '';
								if(document.adminForm.pictwidth.value) otherinfo += '|maxwidth:' + document.adminForm.pictwidth.value;
								if(document.adminForm.pictheight.value) otherinfo += '|maxheight:' + document.adminForm.pictheight.value;
							}else{
								document.getElementById('pictsize').style.display = 'none';
							}
						}
					}
				}
				for(var i = 0; i < document.adminForm.titlelink.length; i++){
					if(document.adminForm.titlelink[i].checked && document.adminForm.register[i].value.length > 1){
						otherinfo += '|' + document.adminForm.titlelink[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.register.length; i++){
					if(document.adminForm.register[i].checked && document.adminForm.register[i].value.length > 1){
						otherinfo += '|' + document.adminForm.register[i].value;
					}
				}
				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{dtregister:' + i + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat' + catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat' + catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateTagAuto();
			}

			function updateTagAuto(){
				tag = '{autodtregister:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '|min:' + document.adminForm.min_article.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '|max:' + document.adminForm.max_article.value;
				}
				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag += '|type:' + document.adminForm.contenttypeauto[i].value;
					}
				}
				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pictauto.length; i++){
						if(document.adminForm.pictauto[i].checked){
							tag += '|pict:' + document.adminForm.pictauto[i].value;
							if(document.adminForm.pictauto[i].value == 'resized'){
								document.getElementById('pictsizeauto').style.display = '';
								if(document.adminForm.pictwidthauto.value) tag += '|maxwidth:' + document.adminForm.pictwidthauto.value;
								if(document.adminForm.pictheightauto.value) tag += '|maxheight:' + document.adminForm.pictheightauto.value;
							}else{
								document.getElementById('pictsizeauto').style.display = 'none';
							}
						}
					}
				}
				for(var i = 0; i < document.adminForm.autotitlelink.length; i++){
					if(document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value.length > 1){
						tag += '|' + document.adminForm.autotitlelink[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.autoregister.length; i++){
					if(document.adminForm.autoregister[i].checked && document.adminForm.autoregister[i].value.length > 1){
						tag += '|' + document.adminForm.autoregister[i].value;
					}
				}
				if(document.adminForm.contentorder.value){
					tag += document.adminForm.contentorder.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					tag += document.adminForm.contentfilter.value;
				}
				if(document.adminForm.delayevent.value && document.adminForm.delayevent.value > 0){
					tag += '|delay:' + document.adminForm.delayevent.value;
				}

				tag += '}';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = acymailing_selectOption("|order:slabId,DESC", acymailing_translation('ACY_ID'));
		$ordering[] = acymailing_selectOption("|order:dtstart,ASC", acymailing_translation('FIELD_DATE'));
		$ordering[] = acymailing_selectOption("|order:title,DESC", acymailing_translation('ACY_TITLE'));


		$contenttype = array();
		$contenttype[] = acymailing_selectOption("title", acymailing_translation('TITLE_ONLY'));
		$contenttype[] = acymailing_selectOption("intro", acymailing_translation('CATEGORY_VIEW'));
		$contenttype[] = acymailing_selectOption("full", acymailing_translation('DETAILS_VIEW'));

		//Title link params
		$titlelink = array();
		$titlelink[] = acymailing_selectOption("link", acymailing_translation('JOOMEXT_YES'));
		$titlelink[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$register = array();
		$register[] = acymailing_selectOption("register", acymailing_translation('JOOMEXT_YES'));
		$register[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('dtregister_tab');
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), 'dtregister_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo acymailing_translation('DISPLAY'); ?></td>
				<td colspan="3"><?php echo acymailing_radio($contenttype, 'contenttype', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo acymailing_translation('CLICKABLE_TITLE'); ?>
				</td>
				<td>
					<?php echo acymailing_radio($titlelink, 'titlelink', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink); ?>
				</td>
				<td>
					<?php echo acymailing_translation('DT_REGISTER'); ?>
				</td>
				<td>
					<?php echo acymailing_radio($register, 'register', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->register); ?>
				</td>
			</tr>
			<tr>
				<td valign="top">
					<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
				</td>
				<td valign="top">
					<?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?>><br/><?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					× <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
				</td>
				<td></td>
				<td></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th class="title"></th>
				<th class="title">
					<?php echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo acymailing_gridSort(acymailing_translation('FIELD_DATE'), 'a.dtstart', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo acymailing_gridSort(acymailing_translation('DT_CATEGORY'), 'b.categoryName', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.slabId', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="6">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			for($i = 0, $a = count($rows); $i < $a; $i++){
				$row =& $rows[$i];
				?>
				<tr id="content<?php echo $row->slabId; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->slabId.",'row$k'" ?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php echo $row->title; ?>
					</td>
					<td>
						<?php echo $row->dtstart; ?>
					</td>
					<td align="center" style="text-align:center">
						<?php echo $row->categoryName; ?>
					</td>
					<td align="center" style="text-align:center">
						<?php echo $row->slabId; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel(acymailing_translation('TAG_CATEGORIES'), 'dtregister_auto');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo acymailing_translation('DISPLAY'); ?></td>
				<td colspan="3"><?php echo acymailing_radio($contenttype, 'contenttypeauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo acymailing_translation('CLICKABLE_TITLE'); ?>
				</td>
				<td>
					<?php echo acymailing_radio($titlelink, 'autotitlelink', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink); ?>
				</td>
				<td>
					<?php echo acymailing_translation('DT_REGISTER'); ?>
				</td>
				<td>
					<?php echo acymailing_radio($register, 'autoregister', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autoregister); ?>
				</td>
			</tr>
			<tr>
				<td valign="top">
					<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
				</td>
				<td valign="top">
					<?php echo acymailing_radio($valImages, 'pictauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($this->params->get('default_pict', '1') != 'resized') echo 'style="display:none;"'; ?> ><br/><?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateAutoTag();" value="<?php echo $this->params->get('maxwidth', '150'); ?>" style="width:30px;"/>
					× <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateAutoTag();" value="<?php echo $this->params->get('maxheight', '150'); ?>" style="width:30px;"/>
				</span>
				</td>
				<td></td>
				<td></td>
			</tr>
			<tr>
				<td>
					<?php echo acymailing_translation('MAX_ARTICLE'); ?>
				</td>
				<td>
					<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo acymailing_translation('MAX_STARTING_DATE'); ?>
				</td>
				<td>
					<?php $delayType = acymailing_get('type.delay');
					$delayType->onChange = "updateTagAuto();";
					echo $delayType->display('delayevent', 7776000, 3); ?>
				</td>
			</tr>
			<tr>
				<?php if($type == 'autonews'){ ?>
					<td>
						<?php echo acymailing_translation('MIN_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
				<?php }else{
					?>
					<td></td>
					<td></td><?php
				} ?>
				<td>
					<?php echo acymailing_translation('ACY_ORDER'); ?>
				</td>
				<td>
					<?php echo acymailing_select($ordering, 'contentorder', 'size="1" style="width:150px;" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>

		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k = 0;
			foreach($this->catvalues as $oneCat){
				if(empty($oneCat->value)) continue;
				?>
				<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo $oneCat->text;
						?>
					</td>
				</tr>
				<?php $k = 1 - $k;
			} ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(acymailing_translation('USERS'), 'dtregister_users');
		$fields = acymailing_loadObjectList("SELECT `id`,`label` FROM #__dtregister_fields ORDER BY `ordering` ASC");
		echo '<table class="adminlist table table-striped table-hover" cellpadding="1">';
		$k = 0;
		foreach($fields as $oneField){
			echo '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{dtuser:'.$oneField->id.'}\');insertTag();" ><td class="acytdcheckbox"></td><td>'.$oneField->label.'</td></tr>';
			$k = 1 - $k;
		}
		echo '</table>';
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){

		//DT Register changed the structure of the categories table... so we check it first
		$ordering = 'ordering';
		$colCats = acymailing_getColumns('#__dtregister_categories');
		if(isset($colCats['lft'])) $ordering = 'lft';

		//select all cats
		$mosetCats = acymailing_loadObjectList('SELECT categoryId,categoryName,parent_id FROM '.acymailing_table('dtregister_categories', false).' ORDER BY `'.$ordering.'` ASC');
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildrens();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	function _handleChildrens($parentId = 0, $level = 0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				//$cat->name = str_repeat($this->separator,$level).$cat->cat_name;
				$this->catvalues[] = acymailing_selectOption($cat->categoryId, str_repeat(" - - ", $level).$cat->categoryName);
				$this->_handleChildrens($cat->categoryId, $level + 1);
			}
		}
	}


	function acymailing_replacetags(&$email, $send = true){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$match = '#{dtregister:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		
		acymailing_loadLanguageFile('com_dtregister', JPATH_SITE);

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				$content = $this->_replaceContent($allresults, $i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content, true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$results, $i){

		//1 : Transform the tag properly...
		$arguments = explode('|', strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int)$arguments[0];
		for($i = 1, $a = count($arguments); $i < $a; $i++){
			$args = explode(':', $arguments[$i]);
			if(isset($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT a.*,c.*,u.username,l.*,l.name AS locationName, d.* '.'FROM #__dtregister_group_event as a '.'LEFT JOIN #__dtregister_categories AS c ON c.categoryId = a.category '.'LEFT JOIN #__users AS u ON u.id = a.user_id '.'LEFT JOIN #__dtregister_locations as l ON l.id=location_id '.'LEFT JOIN #__dtregister_event_detail as d ON d.slabId = a.slabId AND d.type="per_person"'.'WHERE a.slabId = '.$tag->id.''.' LIMIT 1';
		$article = acymailing_loadObject($query);
		$result = '';

		//In case of we could not load the article for any reason...
		if(empty($article)){
			if(acymailing_isAdmin()){
				acymailing_enqueueMessage('The dtregister content "'.$tag->id.'" could not be loaded', 'notice');
			}
			return $result;
		}

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$acypluginsHelper->cleanHtml($article->event_describe);

		if(!empty($article->article_id)){
			$link = 'index.php?option=com_content&view=article&id='.$article->article_id;
		}else{
			$link = 'index.php?option=com_dtregister';
		}
		$link = acymailing_frontendLink($link);

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';

		$resultTitle = '';
		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				$resultTitle = '<a href="'.$link.'" ';
				if($tag->type != "title") $resultTitle .= 'style="text-decoration:none" name="dtregister-'.$article->slabId.'" ';
				$resultTitle .= 'target="_blank" >'.$styleTitle.$article->title.$styleTitleEnd.'</a>';
			}else{
				$resultTitle = $styleTitle.$article->title.$styleTitleEnd;
			}
		}

		//We add the intro text
		if($tag->type != "title"){
			if($tag->type == "full"){

				// Get the article currency from DT register default settings
				$sql = "SELECT `value`
					FROM `#__dtregister_payment_config`
					WHERE `key` = 'currency_code'";
				$currencyCode = acymailing_loadResult($sql);
				if(empty($currencyCode)) $currencyCode = 'USD';

				// Content of DTreg::currency_symbol(), slightly modified
				$arrCode = array('USD' => '$', 'BRL' => 'R$', 'ZAR' => 'R', 'GBP' => '£', 'EUR' => '€', 'JPY' => '¥', 'AUD' => 'AUD $', 'CAD' => 'CAD $', 'HKD' => 'HKD $', 'NZD' => 'NZD $', 'SGD' => 'SGD $', 'RUB' => 'руб.');

				$article->currency = isset($arrCode[$currencyCode]) ? $arrCode[$currencyCode] : $currencyCode;

				$result .= $this->_fullText($article);
			}
			if($article->event_describe_set == '1'){
				$result .= '<div id="textArticle" style="clear:both;">'.$article->event_describe.'</div>';
			}
			$pict = '';
			if(!empty($article->imagepath)) $pict = '<img src="images/dtregister/eventpics/'.$article->imagepath.'" style="float:left;margin-bottom:5px;margin-right:5px;" /><br />';
			$result = $resultTitle.$pict.$result;
			if(!empty($article->article_id)){
				$JoomArticle = acymailing_loadObject('SELECT * FROM #__content WHERE id='.$article->article_id.' LIMIT 1');
				if(!empty($JoomArticle->id)) $result .= '<div id="textJoomla">'.$JoomArticle->introtext.'<br />'.$JoomArticle->fulltext.'</div>';
			}
			if(!empty($tag->register)){
				$result .= '<a target="_blank" href="index.php?option=com_dtregister&eventId='.$tag->id.'&controller=event&task=individualRegister" ><span class="acymailing_readmore">'.acymailing_translation('DT_REGISTER').'</span></a>';
			}
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result;
		}


		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'dtregister.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'dtregister.php');
			$result = ob_get_clean();
		}

		//We remove the JS...
		$result = $acypluginsHelper->removeJS($result);

		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight', 150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth', 150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif(acymailing_isAdmin()){
					acymailing_enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}

		return $result;
	}

	function _fullText($article){
		if($article->amount == '0.00'){
			$article->amount = acymailing_translation('DT_FREE');
		}else{
			$article->amount = $article->currency.' '.$article->amount;
		}
		if($article->max_registrations == '0'){
			$article->max_registrations = acymailing_translation('DT_UNLIMITED');
		}
		$myresult = '<table cellspacing="0" cellpadding="0" border="0">';
		if(!empty($article->locationName)) $myresult .= '<tr><td>'.acymailing_translation('DT_LOCATION').':</td><td><a target="_blank" href="index.php?option=com_dtregister&controller=location&task=show&id='.$article->location_id.'" >'.$article->locationName.'</a></td></tr>';
		if(!empty($article->username)) $myresult .= '<tr><td>'.acymailing_translation('DT_MODERATOR').':</td><td>'.$article->username.'</td></tr>';
		if(!empty($article->dtstart)) $myresult .= '<tr><td>'.acymailing_translation('DT_EVENT_START').':</td><td>'.$article->dtstart.' '.$article->dtstarttime.'</td></tr>';
		if(!empty($article->dtend)) $myresult .= '<tr><td>'.acymailing_translation('DT_EVENT_END').':</td><td>'.$article->dtend.' '.$article->dtendtime.'</td></tr>';
		if(!empty($article->amount)) $myresult .= '<tr><td>'.acymailing_translation('DT_PRICE').':</td><td>'.$article->amount.'</td></tr>';
		if(!empty($article->max_registrations)) $myresult .= '<tr><td>'.acymailing_translation('DT_CAPACITY').':</td><td>'.$article->max_registrations.'</td></tr>';
		if(!empty($article->memberTotal)) $myresult .= '<tr><td>'.acymailing_translation('DT_REGISTERED').':</td><td>'.$article->memberTotal.'</td></tr>';

		$myresult .= '</table>';
		return $myresult;
	}

	function acymailing_replaceusertags(&$email, &$user, $send = true){
		$match = '#{dtuser:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			if(empty($results[$var][0])) unset($results[$var]);
		}
		if(!$found) return;
		$values = null;
		if(!empty($user->userid)){
			$values = acymailing_loadObjectList('SELECT a.*,c.*,c.values as fieldValues FROM #__dtregister_user_field_values AS a '.'LEFT JOIN #__dtregister_user AS b ON a.user_id=b.userId '.'LEFT JOIN #__dtregister_fields AS c ON a.field_id = c.id '.'WHERE b.user_id = '.$user->userid, 'field_id');
		}

		$pluginsHelper = acymailing_get('helper.acyplugins');

		$tags = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($tags[$oneTag])) continue;
				$arguments = explode('|', $allresults[1][$i]);
				$field = $arguments[0];
				unset($arguments[0]);
				$mytag = new stdClass();
				$mytag->default = $this->params->get('default_'.$field, '');
				if(!empty($arguments)){
					foreach($arguments as $onearg){
						$args = explode(':', $onearg);
						if(isset($args[1])){
							$mytag->{$args[0]} = $args[1];
						}else{
							$mytag->{$args[0]} = 1;
						}
					}
				}
				$replaceme = isset($values[$field]->value) ? $values[$field]->value : $mytag->default;
				$allOptions = array();
				if(!empty($values[$field]->type)){
					if($values[$field]->type == 1){
						$allOptions = explode('|', $values[$field]->fieldValues);
						$replaceme = $allOptions[$replaceme];
					}
				}

				$pluginsHelper->formatString($replaceme, $mytag);

				$tags[$oneTag] = $replaceme;
			}
		}
		foreach($results as $var => $allresults){
			$email->$var = str_replace(array_keys($tags), $tags, $email->$var);
		}
	}//endfct

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag, strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result)), $email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();


		//Check if we should generate the SmartNewsletter or not...
		$match = '#{autodtregister:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|', strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-', $arguments[0]);
				$parameter = new stdClass();
				for($i = 1; $i < count($arguments); $i++){
					$args = explode(':', $arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int)$oneCat;
				}

				$query = 'SELECT slabId FROM #__dtregister_group_event ';
				$where = array();
				if(!empty($selectedArea)){
					$where[] = '`category` IN ('.implode(',', $selectedArea).')';
				}


				$date = acymailing_getDate(time(), "%Y-%m-%d");
				$hour = acymailing_getDate(time(), "%H:%M:%S");
				$where[] = '(`dtstart` =\''.$date.'\' '.'AND dtstarttime >\''.$hour.'\') '.'OR `dtstart` >\''.$date.'\'';

				if(!empty($parameter->delay)) $where[] = '`dtstart` <= '.acymailing_escapeDB(acymailing_getDate($time + $parameter->delay, "%Y-%m-%d"));

				$where[] = "publish = 1";


				$query .= ' WHERE ('.implode(') AND (', $where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}
				if(!empty($parameter->max)){
					$query .= ' LIMIT '.(int)$parameter->max;
				}elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT 20';
				//We add a limit for the preview otherwise we could break everything

				$allArticles = acymailing_loadResultArray($query);

				if(!empty($parameter->min) AND count($allArticles) < $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough dtregister content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autodtregister.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autodtregister.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$arrayElements = array();
						foreach($allArticles as $oneArticleId){
							$args = array();
							$args[] = 'dtregister:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(isset($parameter->register)) $args[] = 'register';
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(!empty($parameter->created)) $args[] = 'created';
							if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(isset($parameter->delay)) $args[] = 'delay:'.$parameter->delay;
							if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
							$arrayElements[] = '{'.implode('|', $args).'}';
						}
						$acypluginsHelper = acymailing_get('helper.acyplugins');
						$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}

	function onAcyDisplayFilters(&$type, $context = "massactions"){

		if($this->params->get('displayfilter_'.$context, true) == false) return;


		
		acymailing_loadLanguageFile('com_dtregister');


		try{
			$fields = acymailing_loadObjectList("SELECT `id`,`label` FROM #__dtregister_fields ORDER BY `id` ASC");
		}catch(Exception $e){
			$fields = array();
		}

		if(empty($fields)) return;
		$type['dtregister'] = 'DT Register Fields';
		$dtregisterfields = array();
		foreach($fields as $oneField => $fieldType){
			$dtregisterfields[] = acymailing_selectOption($fieldType->id, $fieldType->label);
		}
		$operators = acymailing_get('type.operators');
		$operators->extra = 'onchange="countresults(__num__)"';
		$return = '<div id="filter__num__dtregister">'.acymailing_select($dtregisterfields, "filter[__num__][dtregister][map]", 'onchange="countresults(__num__)"  class="inputbox" size="1"', 'value', 'text');
		$return .= ' '.$operators->display("filter[__num__][dtregister][operator]").' <input class="inputbox" type="text" name="filter[__num__][dtregister][value]" style="width:200px" value="" onchange="countresults(__num__)"></div>';

		$allGroups = acymailing_loadObjectList("SELECT `title`,`slabId` FROM #__dtregister_group_event ORDER BY `ordering` ASC");
		if(empty($allGroups)) return;

		$firstGroup = new stdClass();
		$firstGroup->title = acymailing_translation('ACY_ALL');
		$firstGroup->slabId = 0;
		array_unshift($allGroups, $firstGroup);

		$type['dtregister_events'] = 'DT Register Events';

		$paidStatus = array();
		$paidStatus[] = acymailing_selectOption('1', acymailing_translation('DT_PAID'));
		$paidStatus[] = acymailing_selectOption('0', acymailing_translation('DT_NOT_PAID'));
		$paidStatus[] = acymailing_selectOption('2', acymailing_translation('DT_BOTH'));

		$attend = array();
		$attend[] = acymailing_selectOption('1', acymailing_translation('DT_ATTENDED'));
		$attend[] = acymailing_selectOption('0', acymailing_translation('DT_NOT_ATTENDED'));
		$attend[] = acymailing_selectOption('2', acymailing_translation('DT_BOTH'));

		$status = array();
		$status['waiting'] = acymailing_translation('DT_WAITING'); //-2
		$status['cancelled'] = acymailing_translation('DT_CANCELLED'); //-1
		$status['pending'] = acymailing_translation('DT_PENDING'); //0
		$status['active'] = acymailing_translation('DT_ACTIVE'); //1

		$return .= '<div id="filter__num__dtregister_events">';

		$return .= acymailing_translation('DT_SELECT_EVENT').' : '.acymailing_select($allGroups, "filter[__num__][dtregister_events][plan]", 'onchange="countresults(__num__)" size="1"', 'slabId', 'title');
		$return .= '<br />'.acymailing_translation('DT_PAYMENT_STATUS').' : '.acymailing_select($paidStatus, "filter[__num__][dtregister_events][fee_status]", 'onchange="countresults(__num__)" size="1"', 'value', 'text', 2);
		$return .= ' <input type="checkbox" id="__num__free" name="filter[__num__][dtregister_events][free]" onchange="countresults(__num__)" /> <label for="__num__free">'.acymailing_translation('DT_INCLUDE_FREE_RECORDS').'</label>';
		$return .= '<br />'.acymailing_translation('DT_ATTENDED').' : '.acymailing_select($attend, "filter[__num__][dtregister_events][attend]", 'onchange="countresults(__num__)" size="1"', 'value', 'text', 2);
		$return .= '<br />'.acymailing_translation('DT_STATUS').' : ';
		foreach($status as $key => $statusName){
			$return .= ' <input type="checkbox" id="__num__status'.$key.'" name="filter[__num__][dtregister_events][status_'.$key.']" onclick="countresults(__num__)" /><label for="__num__status'.$key.'">'.$statusName.'</label>';
		}
		$return .= '</div>';

		return $return;
	}


	function onAcyProcessFilterCount_dtregister(&$query, $filter, $num){
		$filter['map'] = intval($filter['map']);
		$arrayReturn = array();
		$arrayReturn = $this->_typeValue($filter);
		$filter['value'] = $arrayReturn[0];
		$query2 = 'SELECT COUNT(sub.subid) FROM #__acymailing_subscriber as sub '.'LEFT JOIN #__dtregister_user as user ON sub.userid=user.user_id '.'LEFT JOIN #__dtregister_user_field_values as data ON user.userId = data.user_id '.'AND data.field_id = '.(int)$filter['map'].' WHERE '.$query->convertQuery('data', 'value', $filter['operator'], $arrayReturn[0]);
		$nbSubscribers = acymailing_loadResult($query2);
		if(empty($nbSubscribers) && in_array($arrayReturn[1]->type, $this->multipleTypes) && !is_numeric($filter['value'])){
			return acymailing_translation_sprintf('IMPORT_ERROR_FIELD', '<b><i>'.$filter['value'].'</i></b>', str_replace('|', ' / ', $arrayReturn[1]->values));
		}

		return acymailing_translation_sprintf('SELECTED_USERS', $nbSubscribers);
	}

	function onAcyProcessFilter_dtregister(&$query, $filter, $num){

		$filter['map'] = intval($filter['map']);
		$arrayReturn = $this->_typeValue($filter);
		$filter['value'] = $arrayReturn[0];
		$query->leftjoin['dtregister'.$num] = "#__dtregister_user AS dtregister_$num ON sub.userid = dtregister_$num.user_id ";
		$query->leftjoin['dtregister_field_value_'.$num] = "#__dtregister_user_field_values as data_$num "."ON dtregister_$num.userId = data_$num.user_id  "."AND data_$num.field_id = ".(int)$filter['map'];
		$query->where[] = $query->convertQuery("data_$num", 'value', $filter['operator'], $filter['value']);
	}

	function _typeValue($filter){
		$field = acymailing_loadObject('SELECT * FROM #__dtregister_fields WHERE id='.intval($filter['map']).' LIMIT 1');

		if(in_array($field->type, $this->multipleTypes)){
			$valarray = array_flip(explode('|', trim(strtolower($field->values))));
			if(isset($valarray[trim(strtolower($filter['value']))])){
				$filter['value'] = $valarray[trim(strtolower($filter['value']))];
			}
		}

		if($field->type == 5){
			$formatDate = $field->date_format;
			$filter['value'] = acymailing_replaceDate($filter['value']);
			if(!is_numeric($filter['value'])) $filter['value'] = strtotime($filter['value']);
			$filter['value'] = strftime($formatDate, $filter['value']);
		}
		$return = array();
		$return[] = $filter['value'];
		$return[] = $field;
		return $return;
	}

	function _eventsWhere($filter){
		$myquery = 'SELECT DISTINCT u.userId FROM #__dtregister_user as u LEFT JOIN #__dtregister_fee as f ON f.user_id = u.userId';

		$where = array();
		if(!empty($filter['plan'])) $where[] = 'u.eventId = '.intval($filter['plan']);
		$fee = 'f.status IN (0,1)';
		if($filter['fee_status'] == '0' OR $filter['fee_status'] == '1'){
			$fee = 'f.status='.$filter['fee_status'];
		}

		if(!empty($filter['free'])){
			$fee .= ' OR f.fee=0';
		}else $fee .= ' AND f.fee<>0';

		$where[] = $fee;

		if($filter['attend'] == '0' OR $filter['attend'] == '1'){
			$where[] = 'u.attend = '.$filter['attend'];
		}

		$statusPayment = array();
		if(!empty($filter['status_waiting'])) $statusPayment[] = '-2';
		if(!empty($filter['status_cancelled'])) $statusPayment[] = '-1';
		if(!empty($filter['status_pending'])) $statusPayment[] = '0';
		if(!empty($filter['status_active'])) $statusPayment[] = '1';

		if(!empty($statusPayment)) $where[] = 'u.status IN ('.implode(',', $statusPayment).')';

		if(!empty($where)) $myquery .= ' WHERE ('.implode(') AND (', $where).')';

		$allUsersId = acymailing_loadResultArray($myquery);

		if(empty($allUsersId)) return '0=1';

		$fieldemailid = acymailing_loadResult('SELECT id FROM #__dtregister_fields WHERE type = 8 ORDER BY id ASC LIMIT 1');

		$allEmails = acymailing_loadResultArray('SELECT value FROM #__dtregister_user_field_values WHERE user_id IN (\''.implode('\',\'', $allUsersId).'\') AND field_id = '.intval($fieldemailid));

		return 'sub.email IN (\''.implode('\',\'', $allEmails).'\')';
	}

	function onAcyProcessFilterCount_dtregister_events(&$query, $filter, $num){
		$nbSubscribers = acymailing_loadResult('SELECT COUNT(sub.subid) FROM #__acymailing_subscriber as sub WHERE '.$this->_eventsWhere($filter));

		if($nbSubscribers === null){
			return acymailing_getDBError();
		}

		return acymailing_translation_sprintf('SELECTED_USERS', $nbSubscribers);
	}

	function onAcyProcessFilter_dtregister_events(&$query, $filter, $num){
		$query->where[] = $this->_eventsWhere($filter);
	}
}//endclass