<?php
/**
 * @copyright    Copyright (C) 2009-2018 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingicagenda extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'icagenda';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter($plugin->params);
		}

		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_icagenda');
	}

	function acymailing_getPluginType(){
		if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !acymailing_isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'iCagenda';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_icagenda_show(){
		$config = acymailing_config();

		if(version_compare($config->get('version'), '5.6.5', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		
		acymailing_loadLanguageFile('com_icagenda', JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'asc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->filter_type = acymailing_getUserVar($paramBase.".filter_type", 'filter_type', '', 'int');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->contentorderdir = acymailing_getUserVar($paramBase.".contentorderdir", 'contentorderdir', 'DESC', 'string');
		$pageInfo->cols = acymailing_getUserVar($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->pictauto = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = acymailing_getUserVar($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->readmoreauto = acymailing_getUserVar($paramBase.".readmoreauto", 'readmoreauto', '1', 'string');
		$pageInfo->wrap = acymailing_getUserVar($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->clickable = acymailing_getUserVar($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = acymailing_getUserVar($paramBase.".clickableauto", 'clickableauto', '1', 'string');

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.title AS cattitle '.'FROM #__icagenda_events AS a '.'JOIN #__icagenda_category AS b ON a.catid = b.id ';

		//search fields...
		$searchFields = array('a.id', 'a.title', 'b.title');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE ".$searchVal;
		}

		//only published event ?
		if($this->params->get('displaycontent', 'all') == 'onlypub'){
			$filters[] = 'a.state = 1';
		}

		//only approved event ?
		if($this->params->get('displaycontentapproval', 'all') == 'onlyapproved'){
			$filters[] = 'a.approval = 0';
		}

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)){
			$filters[] = 'a.catid = '.intval($pageInfo->filter_cat);
		}

		//apply filters
		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		//apply ordering
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		if(!empty($rows[0]) && !isset($rows[0]->acy_created)){
			acymailing_query('ALTER TABLE `#__icagenda_events` ADD `acy_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP');
		}

		//pagination
		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		//is this a Smart-Newsletter or a simple one ?
		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				<?php
				//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				<?php
				//add the fields the user wants to be displayed
				?>
				for(var i = 0; i < document.adminForm.cbdisplay.length; i++){
					if(document.adminForm.cbdisplay[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbdisplay[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbdisplay[i].value;
						}
					}
				}

				<?php
				//is the title clickable ?
				?>
				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				<?php
				//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				<?php
				//do we have to add a "read more" button ?
				?>
				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				<?php
				//picture management
				?>
				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						if(document.adminForm.pict[i].value != '1'){
							otherinfo += '| pict:' + document.adminForm.pict[i].value;
						}

						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(window.document.getElementById('jflang') && window.document.getElementById('jflang').value != ''){
					otherinfo += '| language:' + window.document.getElementById('jflang').value;
				}

				<?php
				//insert the tags with the right order
				?>
				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				for(var i = 0; i < document.adminForm.cbdisplayauto.length; i++){
					if(document.adminForm.cbdisplayauto[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbdisplayauto[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbdisplayauto[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:" + document.adminForm.wrapauto.value;
				}

				for(var i = 0; i < document.adminForm.readmoreauto.length; i++){
					if(document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				tmp = 0;
				for(var i = 0; i < document.adminForm.autopict.length; i++){
					if(document.adminForm.autopict[i].checked){
						if(document.adminForm.autopict[i].value != '1'){
							otherinfo += '| pict:' + document.adminForm.autopict[i].value;
						}

						if(document.adminForm.autopict[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
				//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}

				<?php
				//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:" + document.adminForm.max_article.value;
				}

				<?php
				//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value + "," + document.adminForm.contentorderdir.value;
				}

				if(window.document.getElementById('jlang') && window.document.getElementById('jlang').value != ''){
					otherinfo += '| lang:' + window.document.getElementById('jlang').value;
				}

				if(window.document.getElementById('jflangauto') && window.document.getElementById('jflangauto').value != ''){
					otherinfo += '| language:' + window.document.getElementById('jflangauto').value;
				}

				<?php if($type == 'autonews'){

				//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}

				if(document.adminForm.mindelayevent && document.adminForm.mindelayevent.value && document.adminForm.mindelayevent.value > 0){
					otherinfo += '| mindelay:' + document.adminForm.mindelayevent.value;
				}
				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value > 0){
					otherinfo += '| delay:' + document.adminForm.delayevent.value;
				}

				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0){
					otherinfo += "| filter:" + document.adminForm.contentfilter.value;
				}

				<?php }else{ ?>
				if(document.adminForm.from_date && document.adminForm.from_date.value){
					otherinfo += '| from:' + document.adminForm.from_date.value;
				}
				if(document.adminForm.to_date && document.adminForm.to_date.value){
					otherinfo += '| to:' + document.adminForm.to_date.value;
				}
				<?php } ?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		// yes/no for the options
		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = acymailing_selectOption("0", acymailing_translation('ACY_ALL'));
		$contentfilter[] = acymailing_selectOption("created", acymailing_translation('ONLY_NEW_CREATED'));
		//$contentfilter[] = JHTML::_('select.option', "modified", acymailing_translation('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		if(ACYMAILING_J30){
			$paginationNb = array();
			$paginationNb[] = acymailing_selectOption(5, 5);
			$paginationNb[] = acymailing_selectOption(10, 10);
			$paginationNb[] = acymailing_selectOption(15, 15);
			$paginationNb[] = acymailing_selectOption(20, 20);
			$paginationNb[] = acymailing_selectOption(25, 25);
			$paginationNb[] = acymailing_selectOption(30, 30);
			$paginationNb[] = acymailing_selectOption(50, 50);
			$paginationNb[] = acymailing_selectOption(100, 100);
			$paginationNb[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'desc', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'ndate', 'label' => 'COM_ICAGENDA_EVENT_DATE_FUTUR', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'place', 'label' => 'COM_ICAGENDA_EVENT_PLACE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'nbseats', 'label' => 'COM_ICAGENDA_EVENT_NUMBER_OF_SEATS', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'avseats', 'label' => 'COM_ICAGENDA_EVENT_NUMBER_OF_SEATS_AVAILABLE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'tel', 'label' => 'COM_ICAGENDA_EVENT_PHONE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'mail', 'label' => 'COM_ICAGENDA_EVENT_MAIL', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'site', 'label' => 'COM_ICAGENDA_EVENT_WEBSITE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'attach', 'label' => 'COM_ICAGENDA_EVENT_FILE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'cat', 'label' => 'COM_ICAGENDA_EVENT_CAT', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'dates', 'label' => 'COM_ICAGENDA_EVENT_DATES', 'checked' => '');

		$contentfilter = array();
		$contentfilter[] = acymailing_selectOption("0", acymailing_translation('ACY_ALL'));
		$contentfilter[] = acymailing_selectOption("created", acymailing_translation('ONLY_NEW_CREATED'));
		$contentfilter[] = acymailing_selectOption("modified", acymailing_translation('ONLY_NEW_MODIFIED'));

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane($this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), $this->name.'_listings');
		?>
		<br style="font-size:1px"/>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<?php
					// what should we display ?
					?>
					<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY'); ?></td>
					<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i % 5 == 0){
							echo '</tr><tr><td/>';
							$i++;
						}
						if($i == 4){
							$jflanguages = acymailing_get('type.jflanguages');
							$jflanguages->onclick = 'onchange="updateTag();"';
							echo '<td>'.$jflanguages->display('jflang').'</td></tr><tr><td/>';
							$i += 2;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.acymailing_translation($oneField['label']).'</label></td>';
						$i++;
					}
					while($i % 5 != 0){
						echo '<td/>';
						$i++;
					}
					?>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

					<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
				</tr>
				<tr>
					<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('DISPLAY_PICTURES'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
					<td nowrap="nowrap" colspan="2" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td nowrap="nowrap" width="100%">
						<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button class="acymailing_button_grey" onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
						<button class="acymailing_button_grey" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php echo $this->_categories($pageInfo->filter_cat); ?>
					</td>
				</tr>
			</table>
			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
						echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
						?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('COM_ICAGENDA_EVENT_DATE'), 'a.startdate', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php
						echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value);
						?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="5">
						<?php
						echo $pagination->getListFooter();
						if(ACYMAILING_J30){
							echo 'Display #'.acymailing_select($paginationNb, 'limit', 'size="1" style="width:60px" onchange="acymailing.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
						}
						echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				if(!empty($rows)){
					foreach($rows as $row){
						?>
						<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'" ?>);" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td style="text-align:center;">
								<?php
								if(!empty($row->title)) echo $row->title;
								?>
							</td>
							<td style="text-align:center;">
								<?php
								if(!empty($row->cattitle)) echo $row->cattitle;
								?>
							</td>
							<td style="text-align:center;">
								<?php
								if(!empty($row->startdate) && $row->startdate != '0000-00-00 00:00:00'){
									echo acymailing_getDate(acymailing_getTime($row->startdate), acymailing_translation('DATE_FORMAT_LC'));
								}else{
									$row->dates = unserialize($row->dates);
									foreach($row->dates as $oneDate){
										if($oneDate == '0000-00-00 00:00:00') continue;
										echo acymailing_getDate(acymailing_getTime($oneDate), acymailing_translation('DATE_FORMAT_LC')).'<br />';
									}
								}
								?>
							</td>
							<td style="text-align:center;">
								<?php
								echo $row->id;
								?>
							</td>
						</tr>
						<?php
						// this enables to know if we have to set the line background grey or white
						$k = 1 - $k;
					}
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>

		<?php
		echo $tabs->endPanel();
		// start category tab
		echo $tabs->startPanel(acymailing_translation('UPCOMING_EVENTS'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<?php
					// what should we display ?
					?>
					<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY'); ?></td>
					<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i % 5 == 0){
							echo '</tr><tr><td/>';
							$i++;
						}

						if($i == 4){
							$jflanguages->onclick = 'onchange="updateTagAuto();"';
							$jflanguages->id = 'jflangauto';
							$langField = $jflanguages->display('jflangauto');
							if(empty($langField) && $jflanguages->multilingue) $langField = $jflanguages->displayJLanguages('jlang');

							echo '<td>'.$langField.'</td></tr><tr><td/>';
							$i += 2;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.acymailing_translation($oneField['label']).'</label></td>';
						$i++;
					}
					while($i % 5 != 0){
						echo '<td/>';
						$i++;
					}
					?>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmoreauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
				</tr>
				<tr>
					<td nowrap="nowrap" valign="top">
						<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
					</td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
						<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
					<td nowrap="nowrap" colspan="2" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				</tr>
				<tr>
					<td nowrap="nowrap" nowrap="nowrap">
						<?php echo acymailing_translation('MAX_ARTICLE'); ?>
					</td>
					<td nowrap="nowrap" colspan="2">
						<input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
					</td>
					<td nowrap="nowrap">
						<?php echo acymailing_translation('ACY_ORDER'); ?>
					</td>
					<td nowrap="nowrap">
						<?php
						$values = array('id' => 'ACY_ID', 'startdate' => 'COM_ICAGENDA_FORM_LBL_EVENTPERIOD_START', 'enddate' => 'COM_ICAGENDA_FORM_LBL_EVENTPERIOD_END', 'next' => 'COM_ICAGENDA_EVENT_DATE_FUTUR', 'title' => 'FIELD_TITLE');
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
						?>
					</td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td nowrap>
							<?php echo acymailing_translation('MIN_ARTICLE'); ?>
						</td>
						<td nowrap colspan="2">
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
						</td>
						<td nowrap>
							<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
						</td>
						<td nowrap>
							<?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
						</td>
					</tr>
					<tr>
						<td nowrap>
							<?php echo acymailing_translation('ACY_FROM_DATE'); ?>
						</td>
						<td nowrap colspan="2">
							<?php $delayType = acymailing_get('type.delay');
							$delayType->onChange = "updateTagAuto();";
							echo $delayType->display('mindelayevent', 0, 3); ?>
						</td>
						<td nowrap>
							<?php echo acymailing_translation('ACY_TO_DATE'); ?>
						</td>
						<td nowrap>
							<?php $delayType = acymailing_get('type.delay');
							$delayType->onChange = "updateTagAuto();";
							echo $delayType->display('delayevent', 7776000, 3); ?>
						</td>
					</tr>
					<tr>
						<td nowrap="nowrap">
							<?php echo acymailing_translation('JOOMEXT_FILTER'); ?>
						</td>
						<td nowrap="nowrap" colspan="4">
							<?php echo acymailing_select($contentfilter, 'contentfilter', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
						</td>
					</tr>
				<?php }else{ ?>
					<tr>
						<td nowrap>
							<?php echo acymailing_translation('ACY_FROM_DATE'); ?>
						</td>
						<td nowrap colspan="2">
							<?php echo acymailing_calendar('', 'from_date', 'from_date', '%Y-%m-%d', array('style' => 'width:80px', 'onchange' => 'updateTagAuto();')); ?>
						</td>
						<td nowrap>
							<?php echo acymailing_translation('ACY_TO_DATE'); ?>
						</td>
						<td nowrap>
							<?php echo acymailing_calendar('', 'to_date', 'to_date', '%Y-%m-%d', array('style' => 'width:80px', 'onchange' => 'updateTagAuto();')); ?>
						</td>
					</tr>
					<tr>
						<td nowrap>
							<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
						</td>
						<td nowrap colspan="4">
							<?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
		<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<div class="onelineblockoptions">
			<table class="acymailing_smalltable" cellpadding="1" width="100%">
				<?php
				$k = 0;
				?>
				<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo acymailing_translation('ACY_ALL');
						?>
					</td>
				</tr>
				<?php
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
						?>
						<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td>
								<?php
								echo $oneCat->text;
								?>
							</td>
						</tr>
						<?php
						$k = 1 - $k;
					}
				}
				?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$mosetCats = acymailing_loadObjectList('SELECT id, title FROM #__icagenda_category ORDER BY title ASC');
		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		if(!empty($mosetCats)){
			foreach($mosetCats as $oneCat){
				$this->catvalues[] = acymailing_selectOption($oneCat->id, $oneCat->title);
			}
		}

		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		
		acymailing_loadLanguageFile('com_icagenda', JPATH_SITE);

		$this->itemid = acymailing_loadResult('SELECT id FROM #__menu WHERE link like "%index.php?option=com_icagenda&view=list%" LIMIT 1');

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$this->newslanguage = new stdClass();
		if(!empty($email->language)){
			$this->newslanguage = acymailing_loadObject('SELECT lang_id, lang_code FROM #__languages WHERE sef = '.acymailing_escapeDB($email->language).' LIMIT 1');
		}

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? acymailing_translation('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.acymailing_translation('JOOMEXT_READ_MORE', true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',', $tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		$content = acymailing_loadObject('SELECT a.*, b.title AS cattitle FROM #__icagenda_events AS a JOIN #__icagenda_category AS b ON a.catid = b.id WHERE a.id = '.intval($tag->id).' LIMIT 1');

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if(acymailing_isAdmin()) acymailing_enqueueMessage('The event "'.$tag->id.'" could not be loaded', 'notice');
			return '';
		}

		if(!empty($tag->language)) $tag->lang = $tag->language;
		if(empty($tag->lang) && !empty($this->newslanguage) && !empty($this->newslanguage->lang_code)) $tag->lang = $this->newslanguage->lang_code.','.$this->newslanguage->lang_id;
		$acypluginsHelper->translateItem($content, $tag, 'icagenda_events');

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		if(!empty($tag->itemid)){
			$itemid = $tag->itemid;
		}else $itemid = $this->params->get('itemid');

		if(empty($itemid)) $itemid = $this->itemid;

		// create the link for the title and the read more button
		$link = 'index.php?option=com_icagenda&view=list&layout=event&id='.$tag->id.':'.$content->alias.'&Itemid='.intval($itemid).'&date='.str_replace(array(' ', ':'), '-', substr($content->next, 0, 16));
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(empty($tag->nolink)){
				$result .= '<a href="'.$link.'">';
			}
			$result .= $content->title;
			if(empty($tag->nolink)){
				$result .= '</a>';
			}
			$result .= '</h2></td></tr>';
		}

		if(!((empty($tag->image) || empty($content->image)) && (empty($tag->desc) || empty($content->desc)))){
			$result .= '<tr><td colspan="2" style="text-align:justify;">';
			if(!(empty($tag->image) || empty($content->image))){
				$result .= '<img style="float:left;" src="'.$content->image.'"/>';
				$varFields['{imagehtml}'] = '<img style="float:left;" src="'.$content->image.'"/>';
			}
			if(!(empty($tag->desc) || empty($content->desc))){
				$result .= $acypluginsHelper->wrapText($content->desc, $tag);
			}
			$result .= '</td></tr>';
		}

		if(!empty($tag->cat)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_CAT').'</strong></td><td valign="top">'.$content->cattitle.'</td></tr>';
		}

		if(!empty($tag->ndate) && !empty($content->next) && $content->next != '0000-00-00 00:00:00'){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_DATE_FUTUR').'</strong></td><td valign="top">'.acymailing_getDate(acymailing_getTime($content->next), acymailing_translation('DATE_FORMAT_LC')).'</td></tr>';
			$varFields['{nextformated}'] = acymailing_getDate(acymailing_getTime($content->next), acymailing_translation('DATE_FORMAT_LC'));
		}

		if(!empty($tag->place) && !(empty($content->place) && empty($content->address))){
			$place = array();
			if(!empty($content->place)){
				$place[] = $content->place;
			}
			if(!empty($content->address)){
				$place[] = $content->address;
			}
			if(!empty($place)){
				$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_PLACE').'</strong></td><td valign="top">'.implode(' - ', $place).'</td></tr>';
				$varFields['{placeformated}'] = implode(' - ', $place);
			}
		}

		$content->params = json_decode($content->params);

		if(!empty($tag->nbseats) && !empty($content->params->maxReg)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_NUMBER_OF_SEATS').'</strong></td><td valign="top">'.$content->params->maxReg.'</td></tr>';
			$varFields['{maxReg}'] = $content->params->maxReg;
		}

		if(!empty($tag->avseats) && !empty($content->params->maxReg)){
			$avseats = $content->params->maxReg - acymailing_loadResult('SELECT SUM(people) FROM #__icagenda_registration WHERE eventid = '.intval($tag->id));
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_NUMBER_OF_SEATS_AVAILABLE').'</strong></td><td valign="top">'.$avseats.'</td></tr>';
			$varFields['{avseats}'] = $avseats;
		}

		if(!empty($tag->tel) && !empty($content->phone)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_PHONE').'</strong></td><td valign="top">'.$content->phone.'</td></tr>';
		}

		if(!empty($tag->mail) && !empty($content->email)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_MAIL').'</strong></td><td valign="top">'.$content->email.'</td></tr>';
		}

		if(!empty($tag->site) && !empty($content->website)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_WEBSITE').'</strong></td><td valign="top"><a href="'.$content->website.'">'.$content->website.'</a></td></tr>';
		}

		if(!empty($tag->attach) && !empty($content->file)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_FILE').'</strong></td><td valign="top"><a href="'.$content->file.'">'.acymailing_translation('COM_ICAGENDA_EVENT_DOWNLOAD').'</a></td></tr>';
		}

		if(!empty($tag->dates)){
			$result .= '<tr><td valign="top"><strong>'.acymailing_translation('COM_ICAGENDA_EVENT_DATES').'</strong></td><td valign="top">';

			$dates = array();
			if(!empty($content->startdate) && $content->startdate != '0000-00-00 00:00:00'){
				$dates[] = acymailing_translation('ACY_FROM_DATE').' '.acymailing_getDate(acymailing_getTime($content->startdate), acymailing_translation('DATE_FORMAT_LC'));
				$varFields['{startdateformated}'] = acymailing_getDate(acymailing_getTime($content->startdate), acymailing_translation('DATE_FORMAT_LC'));
			}
			if(!empty($content->enddate) && $content->enddate != '0000-00-00 00:00:00'){
				$dates[] = acymailing_translation('ACY_TO_DATE').' '.acymailing_getDate(acymailing_getTime($content->enddate), acymailing_translation('DATE_FORMAT_LC'));
				$varFields['{enddateformated}'] = acymailing_getDate(acymailing_getTime($content->enddate), acymailing_translation('DATE_FORMAT_LC'));
			}
			if(!empty($dates)) $result .= implode(' - ', $dates).'<br />';
			if(!empty($content->weekdays)){
				$days = array('0' => 'Sunday', '1' => 'Monday', '2' => 'Tuesday', '3' => 'Wednesday', '4' => 'Thursday', '5' => 'Friday', '6' => 'Saturday');
				$result .= str_replace(array_keys($days), $days, $content->weekdays).'<br />';
			}

			$content->dates = unserialize($content->dates);
			foreach($content->dates as $oneDate){
				if(strpos($oneDate, '0000-00-00') !== false) continue;
				$result .= acymailing_getDate(acymailing_getTime($oneDate), acymailing_translation('DATE_FORMAT_LC')).'<br />';
			}

			$result .= '</td></tr>';
		}

		if(empty($tag->noreadmore)){
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a></td></tr>';
		}

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$pictureHelper = acymailing_get('helper.acypict');
		if(isset($tag->pict)){
			if($tag->pict == 'resized'){
				$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif(acymailing_isAdmin()){
					acymailing_enqueueMessage($pictureHelper->error, 'notice');
				}
			}else{
				$result = $pictureHelper->removePictures($result);
			}
		}
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(empty($this->tags)) return;

		$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);

		if(!empty($email->altbody)){
			$email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
		}

		foreach($this->tags as $tag => $result){
			$email->subject = str_replace($tag, strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result)), $email->subject);
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			if(empty($parameter->order)) $parameter->order = 'startdate,ASC';
			if(empty($parameter->from)) $parameter->from = date('Y-m-d H:i:s', $time);

			$allcats = explode('-', $parameter->id);
			//Load the articles based on all arguments...
			$selectedArea = array();

			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = 'a.catid = '.intval($oneCat);
			}


			$query = 'SELECT a.id FROM #__icagenda_events AS a JOIN #__icagenda_category AS b ON a.catid = b.id ';
			$where = array();

			if(!empty($selectedArea)) $where[] = implode(' OR ', $selectedArea);

			$where[] = 'a.state = 1';
			if(empty($parameter->allaccess)) $where[] = 'a.access = 1';

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				if($parameter->filter == 'created'){
					$where[] = 'a.acy_created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}elseif($parameter->filter == 'modified'){
					$where[] = 'a.acy_created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\' OR a.modified > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}
			}

			if(!empty($parameter->unapproved)){
				$where[] = 'a.approval = 1';
			}else{
				$where[] = 'a.approval = 0';
			}

			if(!empty($parameter->addcurrent)){
				//not finished and next events
				$where[] = 'a.enddate >= '.acymailing_escapeDB($parameter->from).' OR a.next >= '.acymailing_escapeDB($parameter->from);
			}else{
				//not started events
				$where[] = 'a.startdate >= '.acymailing_escapeDB($parameter->from).' OR a.next >= '.acymailing_escapeDB($parameter->from);
			}

			//should we display only events starting in the sending day ?
			if(!empty($parameter->todaysevent)){
				$where[] = '(a.startdate <= '.acymailing_escapeDB(date('Y-m-d 23:59:59', $time)).' AND a.startdate != "0000-00-00 00:00:00") OR a.next <= '.acymailing_escapeDB(date('Y-m-d 23:59:59', $time));
			}

			if(!empty($parameter->mindelay)) $where[] = 'a.startdate >= '.acymailing_escapeDB(date('Y-m-d H:i:s', $time + $parameter->mindelay)).' OR a.next >= '.acymailing_escapeDB(date('Y-m-d H:i:s', $time + $parameter->mindelay));
			if(!empty($parameter->delay)) $where[] = '(a.startdate <= '.acymailing_escapeDB(date('Y-m-d H:i:s', $time + $parameter->delay)).' AND a.startdate != "0000-00-00 00:00:00") OR a.next <= '.acymailing_escapeDB(date('Y-m-d H:i:s', $time + $parameter->delay));
			if(!empty($parameter->to)) $where[] = '(a.startdate <= '.acymailing_escapeDB($parameter->to).' AND a.startdate != "0000-00-00 00:00:00") OR a.next <= '.acymailing_escapeDB($parameter->to);

			if(!empty($parameter->lang)) $where[] = 'a.language = '.acymailing_escapeDB($parameter->lang);

			$query .= ' WHERE ('.implode(') AND (', $where).')';

			// Ordering
			if(!empty($parameter->order)){
				$ordering = explode(',', $parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max)){
				$query .= ' LIMIT '.intval($parameter->max);
			}else{
				$query .= ' LIMIT 20';
			}

			$allArticles = acymailing_loadResultArray($query);

			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}
			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->language)) $args[] = 'language:'.$parameter->language;
						if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}


	function onAcyDisplayFilters(&$type){
		$acyconfig = acymailing_config();
		$type['icagenda'] = 'iCagenda event';
		if(version_compare($acyconfig->get('version'), '4.9.4', '<')) return '<div id="filter__num__icagenda">Please update AcyMailing, the iCagenda plugin may not work properly with this version</div>';
		if(!$this->component_installed) return '<div id="filter__num__icagenda">You must install iCagenda to use this filter</div>';

		
		acymailing_loadLanguageFile('com_icagenda', JPATH_SITE);
		acymailing_loadLanguageFile('com_icagenda', JPATH_ADMINISTRATOR);

		$allEvents = acymailing_loadObjectList('SELECT id, title, catid FROM #__icagenda_events WHERE state != -2 ORDER BY title ASC');
		$eventList = array();

		$categories = acymailing_loadObjectList('SELECT id, title FROM #__icagenda_category ORDER BY title ASC');

		if(!empty($allEvents)){

			foreach($categories as $oneCategory){
				unset($eventsOfThisCategory);
				$eventsOfThisCategory = array();
				foreach($allEvents as $oneEvent){
					if($oneEvent->catid == $oneCategory->id) $eventsOfThisCategory[] = $oneEvent;
				}
				if(!empty($eventsOfThisCategory)){
					$eventList[] = acymailing_selectOption('<OPTGROUP>', $oneCategory->title);
					foreach($eventsOfThisCategory as $oneEvent){
						$eventList[] = acymailing_selectOption($oneEvent->id, $oneEvent->title);
					}
					$eventList[] = acymailing_selectOption('</OPTGROUP>');
				}else{
					$eventList[] = acymailing_selectOption('<OPTGROUP>', $oneCategory->title.' - '.acymailing_translation('COM_ICAGENDA_HEADER_ALL_NO_EVENT'));
					$eventList[] = acymailing_selectOption('</OPTGROUP>');
				}
			}
		}else{
			$eventList[] = acymailing_selectOption('<OPTGROUP>', acymailing_translation('COM_ICAGENDA_HEADER_ALL_NO_EVENT'));
			$eventList[] = acymailing_selectOption('</OPTGROUP>');
		}

		$return = '<div id="filter__num__icagenda">';
		$return .= acymailing_translation('IC_EVENT').' '.acymailing_select($eventList, 'filter[__num__][icagenda][id]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br /><input type="text" name="filter[__num__][icagenda][subdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:70px;" /> < '.acymailing_translation('SUBSCRIPTION_DATE').' < <input type="text" name="filter[__num__][icagenda][subdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:70px;"/></div>';
		return $return;
	}

	function onAcyProcessFilterCount_icagenda(&$query, $filter, $num){
		$this->onAcyProcessFilter_icagenda($query, $filter, $num);
		return acymailing_translation_sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_icagenda(&$query, $filter, $num){
		if(!$this->component_installed) return;
		if(empty($filter['id'])) return;

		if(!empty($filter['subdateinf'])){
			$filter['subdateinf'] = acymailing_replaceDate($filter['subdateinf']);
			if(!is_numeric($filter['subdateinf'])) $filter['subdateinf'] = strtotime($filter['subdateinf']);
			if(!empty($filter['subdateinf'])) $query->where[] = 'icagenda_registration'.$num.'.modified > '.acymailing_escapeDB(date('Y-m-d H:i:s', $filter['subdateinf']));
		}

		if(!empty($filter['subdatesup'])){
			$filter['subdatesup'] = acymailing_replaceDate($filter['subdatesup']);
			if(!is_numeric($filter['subdatesup'])) $filter['subdatesup'] = strtotime($filter['subdatesup']);
			if(!empty($filter['subdatesup'])) $query->where[] = 'icagenda_registration'.$num.'.modified < '.acymailing_escapeDB(date('Y-m-d H:i:s', $filter['subdatesup']));
		}

		$query->join[] = '#__icagenda_registration AS icagenda_registration'.$num.' ON icagenda_registration'.$num.'.email = sub.email';
		if($filter['id'] != "") $query->where[] = 'icagenda_registration'.$num.'.eventid = '.intval($filter['id']);
		$query->where[] = 'icagenda_registration'.$num.'.state != -2';
	}

}//endclass
?>