<?php
/**
 * @copyright    Copyright (C) 2009-2018 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingMatukio extends JPlugin{
	var $cats = array();
	var $catvalues = array();
	var $newslanguage;
	var $readmore = '';
	var $tags = array();

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'matukio';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter($plugin->params);
		}

		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_matukio');
	}

	function acymailing_getPluginType(){
		if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !acymailing_isAdmin())) return '';
		$onePlugin = new stdClass();
		$onePlugin->name = 'Matukio';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_matukio_show(){
		$config = acymailing_config();

		if(version_compare($config->get('version'), '5.1.0', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		
		acymailing_loadLanguageFile('com_matukio', JPATH_SITE);
		acymailing_loadLanguageFile('com_matukio', JPATH_ADMINISTRATOR);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'asc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->filter_type = acymailing_getUserVar($paramBase.".filter_type", 'filter_type', '', 'int');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->contentorderdir = acymailing_getUserVar($paramBase.".contentorderdir", 'contentorderdir', 'DESC', 'string');
		$pageInfo->cols = acymailing_getUserVar($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->pictauto = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = acymailing_getUserVar($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->readmoreauto = acymailing_getUserVar($paramBase.".readmoreauto", 'readmoreauto', '1', 'string');
		$pageInfo->wrap = acymailing_getUserVar($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->clickable = acymailing_getUserVar($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = acymailing_getUserVar($paramBase.".clickableauto", 'clickableauto', '1', 'string');

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS r.id AS recurringId, r.begin AS begin, a.*, b.title AS cattitle FROM #__matukio AS a JOIN #__categories AS b ON a.catid = b.id LEFT JOIN #__matukio_recurring AS r ON a.id = r.event_id';

		//search fields...
		$searchFields = array('a.id', 'a.title', 'b.title', 'r.begin');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent', 'all') == 'onlypub') $filters[] = 'a.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'a.catid = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search, $rows);

		//pagination
		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		//is this a Smart-Newsletter or a simple one ?
		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid);
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					var recurring = window.document.getElementById('content' + contentid).getAttribute('recurring');
					if(recurring != null){
						selectedContents.push(recurring);
					}else{
						selectedContents.push(contentid);
					}
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('catall').className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('catall').className = 'selectedrow';
						var key;
						for(key in selectedCat){
							if(isNaN(key)) continue;
							window.document.getElementById('cat' + key).className = rowClass;
							delete selectedCat[key];
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				<?php
				//add the fields the user wants to be displayed
				?>
				for(var i = 0; i < document.adminForm.cbdisplay.length; i++){
					if(!document.adminForm.cbdisplay[i].checked) continue;
					if(tmp == 0){
						tmp += 1;
						otherinfo += "| display:" + document.adminForm.cbdisplay[i].value;
					}else{
						otherinfo += ", " + document.adminForm.cbdisplay[i].value;
					}
				}

				if(document.adminForm.contentformat && document.adminForm.contentformat.value){
					otherinfo += '| format:' + document.adminForm.contentformat.value;
				}

				if(document.adminForm.customfields){
					if(document.adminForm.customfields.length == undefined){
						if(document.adminForm.customfields.checked) otherinfo += "| custom:" + document.adminForm.customfields.value;
					}else{
						tmp = 0;
						for(i = 0; i < document.adminForm.customfields.length; i++){
							if(!document.adminForm.customfields[i].checked) continue;
							if(tmp == 0){
								tmp += 1;
								otherinfo += "| custom:" + document.adminForm.customfields[i].value;
							}else{
								otherinfo += ", " + document.adminForm.customfields[i].value;
							}
						}
					}
				}

				<?php
				//is the title clickable ?
				?>
				for(i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				for(i = 0; i < document.adminForm.remdescimg.length; i++){
					if(document.adminForm.remdescimg[i].checked && document.adminForm.remdescimg[i].value == '1'){
						otherinfo += '| remdescimg';
					}
				}

				<?php
				//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				<?php
				//do we have to add a "read more" button ?
				?>
				for(i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				<?php
				//picture management
				?>
				for(i = 0; i < document.adminForm.pict.length; i++){
					if(!document.adminForm.pict[i].checked) continue;
					if(document.adminForm.pict[i].value != '1') otherinfo += '| pict:' + document.adminForm.pict[i].value;

					if(document.adminForm.pict[i].value == 'resized'){
						document.getElementById('pictsize').style.display = '';
						if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
						if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
					}else{
						document.getElementById('pictsize').style.display = 'none';
					}
				}

				for(i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var otherinfo = '';
				var tmp = 0;

				for(var i = 0; i < document.adminForm.cbdisplayauto.length; i++){
					if(!document.adminForm.cbdisplayauto[i].checked) continue;
					if(tmp == 0){
						tmp += 1;
						otherinfo += "| display:" + document.adminForm.cbdisplayauto[i].value;
					}else{
						otherinfo += ", " + document.adminForm.cbdisplayauto[i].value;
					}
				}

				if(document.adminForm.customfieldsauto){
					if(document.adminForm.customfieldsauto.length == undefined){
						if(document.adminForm.customfieldsauto.checked) otherinfo += "| custom:" + document.adminForm.customfieldsauto.value;
					}else{
						tmp = 0;
						for(i = 0; i < document.adminForm.customfieldsauto.length; i++){
							if(!document.adminForm.customfieldsauto[i].checked) continue;
							if(tmp == 0){
								tmp += 1;
								otherinfo += "| custom:" + document.adminForm.customfieldsauto[i].value;
							}else{
								otherinfo += ", " + document.adminForm.customfieldsauto[i].value;
							}
						}
					}
				}

				for(i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						otherinfo += '| nolink';
					}
				}

				for(i = 0; i < document.adminForm.remdescimgauto.length; i++){
					if(document.adminForm.remdescimgauto[i].checked && document.adminForm.remdescimgauto[i].value == '1'){
						otherinfo += '| remdescimg';
					}
				}

				if(document.adminForm.contentformatauto && document.adminForm.contentformatauto.value){
					otherinfo += '| format:' + document.adminForm.contentformatauto.value;
				}
				if(document.getElementById('contentformatautoinvert').value == 1) otherinfo += '| invert';

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:" + document.adminForm.wrapauto.value;
				}

				for(i = 0; i < document.adminForm.readmoreauto.length; i++){
					if(document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				for(i = 0; i < document.adminForm.autopict.length; i++){
					if(!document.adminForm.autopict[i].checked) continue;
					if(document.adminForm.autopict[i].value != '1') otherinfo += '| pict:' + document.adminForm.autopict[i].value;

					if(document.adminForm.autopict[i].value == 'resized'){
						document.getElementById('pictsizeauto').style.display = '';
						if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidthauto.value;
						if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:' + document.adminForm.pictheightauto.value;
					}else{
						document.getElementById('pictsizeauto').style.display = 'none';
					}
				}

				<?php
				//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:" + document.adminForm.cols.value;
				}

				<?php
				//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:" + document.adminForm.max_article.value;
				}

				<?php
				//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:" + document.adminForm.contentorder.value + "," + document.adminForm.contentorderdir.value;
				}

				if(document.adminForm.from_date && document.adminForm.from_date.value){
					otherinfo += '| from:' + document.adminForm.from_date.value;
				}
				if(document.adminForm.to_date && document.adminForm.to_date.value){
					otherinfo += '| to:' + document.adminForm.to_date.value;
				}

				<?php if($type == 'autonews'){
				//minimum number of content for the newsletter to be displayed...
				?>
				if(document.adminForm.mindelayevent && document.adminForm.mindelayevent.value && document.adminForm.mindelayevent.value > 0){
					otherinfo += '| mindelay:' + document.adminForm.mindelayevent.value;
				}
				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value > 0){
					otherinfo += '| delay:' + document.adminForm.delayevent.value;
				}
				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}
				<?php }
				//insert the tag
				?>
				var tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}
				tag += otherinfo + '}<br />';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		// yes/no for the options
		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'shortdesc', 'label' => 'COM_MATUKIO_BRIEF_DESCRIPTION', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'COM_MATUKIO_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'startdate', 'label' => 'COM_MATUKIO_START', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'enddate', 'label' => 'COM_MATUKIO_END', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'closedate', 'label' => 'COM_MATUKIO_CLOSING_DATE_SHORT', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'price', 'label' => 'COM_MATUKIO_FEES', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'capacity', 'label' => 'COM_MATUKIO_MAX_PARTICIPANT', 'checked' => '');

		$fieldsDisplay[] = array('title' => 'rcapacity', 'label' => 'COM_MATUKIO_BOOKABLE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'location', 'label' => 'COM_MATUKIO_CITY', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'booknow', 'label' => 'COM_MATUKIO_BOOK_NOW', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'category', 'label' => 'ACY_CATEGORY', 'checked' => '');

		$customFields = acymailing_loadObjectList('SELECT slug AS id, title FROM #__compojoom_customfields WHERE enabled = 1 AND component LIKE "%com_matukio%"');

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane($this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), $this->name.'_listings');
		?>
		<br style="font-size:1px"/>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr id="format" class="acyplugformat">
					<td valign="top">
						<?php echo acymailing_translation('FORMAT'); ?>
					</td>
					<td valign="top" colspan="2">
						<?php echo $this->acypluginsHelper->getFormatOption($this->name); ?>
					</td>
					<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('DISPLAY_PICTURES'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<label for="pictwidth"><?php echo acymailing_translation('CAPTCHA_WIDTH') ?></label>
						<input id="pictwidth" name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <label for="pictheight"><?php echo acymailing_translation('CAPTCHA_HEIGHT') ?></label>
						<input id="pictheight" name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY'); ?></td>
					<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(acymailing_translation($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
					?>
				</tr>
				<?php
				//handle custom fields
				if(!empty($customFields)){
					echo '<tr><td>'.acymailing_translation('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam){
						if($i == 5){
							$i = 1;
							echo '</tr><tr><td/>';
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfields" id="cf_'.$oneParam->id.'" type="checkbox" onclick="updateTag();"/>';
						echo '<label style="margin-left:5px" for="cf_'.$oneParam->id.'">'.$oneParam->title.'</label></td>';
						$i++;
					}
					while($i != 5){
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
				?>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

					<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('ACY_REMOVE_DESC_IMAGES'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'remdescimg', 'size="1" onclick="updateTag();"', 'value', 'text', '0'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td nowrap="nowrap" width="100%">
						<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button class="acymailing_button" onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
						<button class="acymailing_button" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php echo $this->_categories($pageInfo->filter_cat); ?>
					</td>
				</tr>
			</table>
			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th></th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('ACY_DATE_BEGIN'), 'r.begin', $pageInfo->filter->order->dir, $pageInfo->filter->order->value)?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="4">
						<?php
						echo $pagination->getListFooter();
						if(ACYMAILING_J30){
							$paginationNb = array();
							foreach(array(5, 10, 15, 20, 25, 30, 50, 100) as $oneOption){
								$paginationNb[] = acymailing_selectOption($oneOption, $oneOption);
							}
							$paginationNb[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
							echo 'Display #'.acymailing_select($paginationNb, 'limit', 'size="1" style="width:60px" onchange="acymailing.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
						}
						echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				if(!empty($rows)){
					foreach($rows as $row){
						!empty($row->recurringId)? $idOfThisRow = $row->id.$row->recurringId : $idOfThisRow = $row->id;
						?>
						<tr id="content<?php echo $idOfThisRow; ?>" <?php if(!empty($row->recurringId)) echo 'recurring="'.$row->id.'-'.$row->recurringId.'"';?> class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $idOfThisRow.",'row$k'" ?>);" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td style="text-align:center;">
								<?php
								if(!empty($row->title)) echo $row->title;
								?>
							</td>
							<td style="text-align:center;">
								<?php
								if (!empty($row->begin)) echo acymailing_date($row->begin, acymailing_translation('DATE_FORMAT_LC2'));
								?>
							</td>
							<td style="text-align:center;">
								<?php
								if(!empty($row->cattitle)) echo $row->cattitle;
								?>
							</td>
							<td style="text-align:center;">
								<?php
								echo $row->id;
								?>
							</td>
						</tr>
						<?php
						// this enables to know if we have to set the line background grey or white
						$k = 1 - $k;
					}
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>

		<?php
		echo $tabs->endPanel();
		// start category tab
		echo $tabs->startPanel(acymailing_translation('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr id="formatauto" class="acyplugformat">
					<td valign="top">
						<?php echo acymailing_translation('FORMAT'); ?>
					</td>
					<td valign="top">
						<?php echo $this->acypluginsHelper->getFormatOption($this->name, 'TOP_LEFT', false, 'updateTagAuto'); ?>
					</td>
					<td nowrap="nowrap" valign="top">
						<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
					</td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
						<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<label for="pictwidthauto"><?php echo acymailing_translation('CAPTCHA_WIDTH') ?></label>
						<input id="pictwidthauto" name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <label for="pictheightauto"><?php echo acymailing_translation('CAPTCHA_HEIGHT') ?></label>
						<input id="pictheightauto" name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
				</tr>
				<tr>
					<?php
					// what should we display ?
					?>
					<td nowrap="nowrap"><?php echo acymailing_translation('DISPLAY'); ?></td>
					<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}//TODO for the language, see icagenda
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.trim(acymailing_translation($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
					?>
				</tr>
				<?php
				//handle custom fields
				if(!empty($customFields)){
					echo '<tr><td>'.acymailing_translation('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam){
						if($i == 5){
							$i = 1;
							echo '</tr><tr><td/>';
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfieldsauto" id="autocf_'.$oneParam->id.'auto" type="checkbox" onclick="updateTagAuto();"/>';
						echo '<label style="margin-left:5px" for="autocf_'.$oneParam->id.'auto">'.$oneParam->title.'</label></td>';
						$i++;
					}
					while($i != 5){
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
				?>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_translation('JOOMEXT_READ_MORE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'readmoreauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('ACY_REMOVE_DESC_IMAGES'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_radio($choice, 'remdescimgauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', '0'); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td>
							<?php echo acymailing_translation('MIN_ARTICLE'); ?>
						</td>
						<td colspan="2">
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
						</td>
						<td><?php echo acymailing_translation('FIELD_COLUMNS'); ?></td>
						<td><?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?></td>
					</tr>
					<tr>
						<td nowrap="nowrap">
							<label for="max_article"><?php echo acymailing_translation('MAX_ARTICLE'); ?></label>
						</td>
						<td nowrap="nowrap" colspan="2">
							<input type="text" id="max_article" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
						</td>
						<td nowrap="nowrap">
							<?php echo acymailing_translation('ACY_ORDER'); ?>
						</td>
						<td nowrap="nowrap">
							<?php
							$values = array('id' => 'ACY_ID', 'begin' => 'COM_MATUKIO_START', 'publish_on' => 'CREATED_DATE', 'modified_on' => 'MODIFIED_DATE', 'title' => 'FIELD_TITLE');
							echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
							?>
						</td>
					</tr>
					<tr>
						<td>
							<?php echo acymailing_translation('ACY_FROM_DATE'); ?>
						</td>
						<td colspan="2">
							<?php $delayType = acymailing_get('type.delay');
							$delayType->onChange = "updateTagAuto();";
							echo $delayType->display('mindelayevent', 0, 3); ?>
						</td>
						<td>
							<?php echo acymailing_translation('ACY_TO_DATE'); ?>
						</td>
						<td>
							<?php $delayType = acymailing_get('type.delay');
							$delayType->onChange = "updateTagAuto();";
							echo $delayType->display('delayevent', 7776000, 3); ?>
						</td>
					</tr>
				<?php }else{ ?>
					<tr>
						<td><?php echo acymailing_translation('FIELD_COLUMNS'); ?></td>
						<td colspan="4"><?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?></td>
					</tr>
					<tr>
						<td nowrap="nowrap">
							<label for="max_article"><?php echo acymailing_translation('MAX_ARTICLE'); ?></label>
						</td>
						<td nowrap="nowrap" colspan="2">
							<input type="text" id="max_article" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
						</td>
						<td nowrap="nowrap">
							<?php echo acymailing_translation('ACY_ORDER'); ?>
						</td>
						<td nowrap="nowrap">
							<?php
							$values = array('id' => 'ACY_ID', 'begin' => 'COM_MATUKIO_START', 'publish_on' => 'CREATED_DATE', 'modified_on' => 'MODIFIED_DATE', 'title' => 'FIELD_TITLE');
							echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
							?>
						</td>
					</tr>
					<tr>
						<td>
							<?php echo acymailing_translation('ACY_FROM_DATE'); ?>
						</td>
						<td colspan="2">
							<?php echo acymailing_calendar('', 'from_date', 'from_date', '%Y-%m-%d', array('style' => 'width:80px', 'onchange' => 'updateTagAuto();')); ?>
						</td>
						<td>
							<?php echo acymailing_translation('ACY_TO_DATE'); ?>
						</td>
						<td>
							<?php echo acymailing_calendar('', 'to_date', 'to_date', '%Y-%m-%d', array('style' => 'width:80px', 'onchange' => 'updateTagAuto();')); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table" cellpadding="1" width="100%">
				<tr id="catall" class="<?php echo "row0"; ?>" onclick="applyAuto('all','<?php echo "row0" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td><?php echo acymailing_translation('ACY_ALL'); ?></td>
				</tr>
				<?php
				$k = 1;
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
						?>
						<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td>
								<?php
								echo $oneCat->text;
								?>
							</td>
						</tr>
						<?php
						$k = 1 - $k;
					}
				}
				?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	private function _categories($filter_cat){
		//select all cats
		$cats = acymailing_loadObjectList('SELECT id, parent_id, title FROM #__categories WHERE extension = "com_matukio" ORDER BY id ASC');
		if(!empty($cats)){
			foreach($cats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildren();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	private function _handleChildren($parent_id = 1, $level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = acymailing_selectOption($cat->id, str_repeat(" - - ", $level).$cat->title);
			$this->_handleChildren($cat->id, $level + 1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		
		acymailing_loadLanguageFile('com_matukio', JPATH_SITE);
		acymailing_loadLanguageFile('com_matukio', JPATH_ADMINISTRATOR);

		$this->customfields = acymailing_loadObjectList('SELECT * FROM #__compojoom_customfields WHERE component LIKE "%com_matukio%"', 'slug');
		if(!empty($this->customfields)){
			foreach($this->customfields as &$oneField){
				$oneField->params = json_decode($oneField->params);
				if($oneField->type != 'list') continue;
				$oneField->options = explode("\n", $oneField->options);
				foreach($oneField->options as $i => $oneOption){
					$oneField->options[$i] = explode('=', $oneOption);
				}
			}
		}
		include_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_matukio'.DS.'helpers'.DS.'settings.php');
		include_once(JPATH_BASE.DS.'components'.DS.'com_matukio'.DS.'helpers'.DS.'events.php');
		include_once(JPATH_BASE.DS.'components'.DS.'com_matukio'.DS.'helpers'.DS.'currencies.php');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? acymailing_translation('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.acymailing_translation('JOOMEXT_READ_MORE', true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	private function _replaceContent(&$tag){

		// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',', $tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
		}

		// load content
		$content = acymailing_loadObject('SELECT a.*, b.title AS cattitle, c.title AS loctitle, c.location
							FROM #__matukio AS a
							JOIN #__categories AS b ON a.catid = b.id
							LEFT JOIN #__matukio_locations AS c ON a.place_id = c.id
							WHERE a.id = '.intval($tag->id).' LIMIT 1');


		if(strpos($tag->id, '-')){
			$ids = explode('-', $tag->id);
			$recurring = acymailing_loadObject('SELECT begin, end, booked FROM #__matukio_recurring WHERE id = '.intval($ids[1]).' AND event_id = '.intval($ids[0]).' LIMIT 1');
			$content->begin = $recurring->begin;
			$content->end = $recurring->end;
			$content->booked = $recurring->booked;
			$recurringId = $ids[1];
		}




		//In case of we could not load the article for any reason...
		if(empty($content)){
			if(acymailing_isAdmin()) acymailing_enqueueMessage('The content "'.$tag->id.'" could not be loaded', 'notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		$afterTitle = '';
		$afterArticle = '';
		$contentText = '';
		$customFields = array();



		// create the link for the title and the read more button
		$idLink = $tag->id;

		if(empty($recurringId)){
			$recurringId = acymailing_loadResult('SELECT id FROM #__matukio_recurring WHERE event_id = '.intval($tag->id).' AND end > '.acymailing_escapeDB(date('Y-m-d H:i:s', time())).' LIMIT 1');
		}
		if(!empty($recurringId)) $idLink = $recurringId;

		$link = 'index.php?option=com_matukio&view=event&catid='.$content->catid.'&id='.$idLink;
		if(!empty($tag->itemid)){
			$link .= '&Itemid='.$tag->itemid;
		}elseif(!empty($this->params->get('itemid', ''))) $link .= '&Itemid='.$this->params->get('itemid');
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		if(!empty($tag->shortdesc)) $contentText .= $content->shortdesc;
		if(!empty($tag->description)) $contentText .= $content->description;
		$contentText = $this->acypluginsHelper->wrapText($contentText, $tag);
		if(!empty($tag->remdescimg)) $contentText = preg_replace('#<img[^>]*>#Uis', '', $contentText);
		$varFields['{contentText}'] = $contentText;

		if(!empty($tag->startdate) && $content->begin != '0000-00-00 00:00:00'){
			$varFields['{startdate}'] = acymailing_date($content->begin, acymailing_translation('DATE_FORMAT_LC2'));
			$customFields[] = array(acymailing_translation('COM_MATUKIO_START'), $varFields['{startdate}']);
		}

		if(!empty($tag->enddate) && $content->end != '0000-00-00 00:00:00'){
			$varFields['{enddate}'] = acymailing_date($content->end, acymailing_translation('DATE_FORMAT_LC2'));
			$customFields[] = array(acymailing_translation('COM_MATUKIO_END'), $varFields['{enddate}']);
		}

		if(!empty($tag->closedate) && $content->booked != '0000-00-00 00:00:00'){
			$varFields['{bookeddate}'] = acymailing_date($content->booked, acymailing_translation('DATE_FORMAT_LC2'));
			$customFields[] = array(acymailing_translation('COM_MATUKIO_CLOSING_DATE_SHORT'), $varFields['{bookeddate}']);
		}

		if(!empty($tag->price)){
			$varFields['{price}'] = MatukioHelperEvents::getFormatedCurrency($content->fees, $content);
			$customFields[] = array(acymailing_translation('COM_MATUKIO_FEES'), $varFields['{price}']);
		}

		if(!empty($tag->capacity) && !empty($content->maxpupil)) $customFields[] = array(acymailing_translation('COM_MATUKIO_MAX_PARTICIPANT'), $content->maxpupil);

		if(!empty($tag->rcapacity) && !empty($content->maxpupil)){
			$paid = $this->params->get('remainingpaid', '1') == 1 ? ' AND paid = 1' : '';
			$numberOfTakenPlaces = acymailing_loadResult('SELECT SUM(nrbooked) FROM #__matukio_bookings WHERE status = 1'.$paid.' AND payment_status = "P" AND semid = '.intval($recurringId));

			$remainingPlaces = $content->maxpupil - intval($numberOfTakenPlaces);
			if($remainingPlaces < 0) $remainingPlaces = 0;

			$customFields[] = array(acymailing_translation('COM_MATUKIO_BOOKABLE'), $remainingPlaces);
		}

		if(!empty($tag->location)){
			if(empty($content->place_id)){
				$varFields['{location}'] = $content->place;
			}else $varFields['{location}'] = $content->loctitle;
			$customFields[] = array(acymailing_translation('COM_MATUKIO_CITY'), $varFields['{location}']);
		}

		// display the category
		if(!empty($tag->category)) $customFields[] = array(acymailing_translation('ACY_CATEGORY'), $content->cattitle);

		if(!empty($tag->custom) && !empty($content->customfields) && $content->customfields != 'null'){
			$content->customfields = json_decode($content->customfields);

			$tag->custom = explode(',', $tag->custom);
			foreach($tag->custom as $i => $oneDisplay){
				$currentField = trim($oneDisplay);
				if(!isset($content->customfields->$currentField) || empty($this->customfields[$currentField]) || ($this->customfields[$currentField]->type != 'checkbox' && empty($content->customfields->$currentField))) continue;
				if($this->customfields[$currentField]->type == 'list'){
					$fieldValue = acymailing_translation('ACY_NONE');
					foreach($this->customfields[$currentField]->options as $oneOption){
						if($content->customfields->$currentField == $oneOption[0]) $fieldValue = $oneOption[1];
					}
				}elseif($this->customfields[$currentField]->type == 'checkbox'){
					$fieldValue = $content->customfields->$currentField == 1 ? acymailing_translation('JOOMEXT_YES') : acymailing_translation('JOOMEXT_NO');
				}elseif($this->customfields[$currentField]->type == 'url'){
					$fieldValue = '<a href="'.$content->customfields->$currentField.'">'.$content->customfields->$currentField.'</a>';
				}else{
					$fieldValue = $content->customfields->$currentField;
				}

				$varFields['{cf|'.$currentField.'}'] = $fieldValue;

				if($this->customfields[$currentField]->params->show_label == 1){
					$customFields[] = array(acymailing_translation($this->customfields[$currentField]->title), $fieldValue);
				}else $customFields[] = array($content->cattitle);
			}
		}

		if(!empty($tag->booknow)){
			$xml = JFactory::getXML(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_matukio'.DS.'matukio.xml');
			$version = (string)$xml->version;
			if ($version[0] >= '7'){
				$varFields['{booknow}'] = '<a class="booknow" href="index.php?option=com_matukio&view=book&event_id='.$idLink.'">'.acymailing_translation('COM_MATUKIO_BOOK_NOW').'</a>';
				$afterArticle .= '<br/>'.$varFields['{booknow}'];
			}else{
				$varFields['{booknow}'] = '<a class="booknow" href="index.php?option=com_matukio&view=book&cid='.$idLink.'">'.acymailing_translation('COM_MATUKIO_BOOK_NOW').'</a>';
				$afterArticle .= '<br/>'.$varFields['{booknow}'];
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		$afterArticle .= empty($tag->noreadmore) ? '<br/>'.$varFields['{readmore}'] : '';

		$format = new stdClass();
		$format->tag = $tag;
		$format->title = empty($tag->notitle) ? $content->title : '';
		$format->afterTitle = $afterTitle;
		$format->afterArticle = $afterArticle;
		$format->imagePath = $content->image;
		$format->description = $contentText;
		$format->link = empty($tag->nolink) ? $link : '';
		$format->cols = empty($tag->nbcols) ? 1 : intval($tag->nbcols);
		$format->customFields = $customFields;
		$result = '<div class="acymailing_content">'.$this->acypluginsHelper->getStandardDisplay($format).'</div>';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		$result = $this->acypluginsHelper->removeJS($result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$time = time();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			if(empty($parameter->from)) $parameter->from = date('Y-m-d H:i:s', $time);

			$allcats = explode('-', $parameter->id);
			//Load the articles based on all arguments...
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id, b.id AS rid FROM #__matukio AS a JOIN #__matukio_recurring AS b ON a.id = b.event_id ';

			$where = array();

			if(!empty($parameter->addcurrent)){
				//not finished and next events
				$where[] = 'b.`end` >= '.acymailing_escapeDB($parameter->from);
			}else{
				//not started events
				$where[] = 'b.`begin` >= '.acymailing_escapeDB($parameter->from);
			}

			//should we display only events starting in the sending day ?
			if(!empty($parameter->todaysevent)) $where[] = 'b.`begin` <= '.acymailing_escapeDB(date('Y-m-d 23:59:59', $time));
			if(!empty($parameter->mindelay)) $where[] = 'b.`begin` >= '.acymailing_escapeDB(date('Y-m-d H:i:s', $time + $parameter->mindelay));
			if(!empty($parameter->delay)) $where[] = 'b.`begin` <= '.acymailing_escapeDB(date('Y-m-d H:i:s', $time + $parameter->delay));
			if(!empty($parameter->to)) $where[] = 'b.`begin` <= '.acymailing_escapeDB($parameter->to);

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'a.catid IN ('.implode(',', $selectedArea).')';

			// Only published content
			if(empty($parameter->unpublished)) $where[] = 'a.published = 1';
			if(!empty($parameter->hotevent)) $where[] = 'a.hot_event = 1';
			if(!empty($parameter->nohotevent)) $where[] = 'a.hot_event = 0';
			if(!empty($parameter->topevent)) $where[] = 'a.top_event = 1';
			if(!empty($parameter->notopevent)) $where[] = 'a.top_event = 0';

			if(!empty($parameter->onlypaid)) $where[] = 'a.fees != 0';
			if(!empty($parameter->onlyfree)) $where[] = 'a.fees = 0';

			if(!empty($parameter->recurring)) $where[] = 'a.recurring = 1';
			if(!empty($parameter->norecurring)) $where[] = 'a.recurring = 0';

			if(!empty($parameter->access)) $where[] = 'a.access = '.intval($parameter->access);

			if(!empty($parameter->created) && !empty($email->params['lastgenerateddate'])){
				$where[] = 'a.publishdate > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\' AND a.publishdate < \''.date('Y-m-d H:i:s', $time - date('Z')).'\'';
			}

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (', $where).')';

			// Ordering
			if(!empty($parameter->order)){
				$ordering = explode(',', $parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}elseif($ordering[0] == 'begin'){
					$query .= ' ORDER BY b.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}else{
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 20;
			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.intval($parameter->max);


			// load content IDs
			$allArticles = acymailing_loadObjectList($query);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					unset($parameter->id);
					$numArticle = 1;
					foreach($allArticles as $oneArticle){
						$numArticle++;
						$args = array();
						$args[] = $this->name.':'.$oneArticle->id.'-'.$oneArticle->rid;
						foreach($parameter as $oneParam => $val){
							if($oneParam == 'invert' && $numArticle % 2 == 0) continue;
							if(is_bool($val)){
								$args[] = $oneParam;
							}else $args[] = $oneParam.':'.$val;
						}
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		$acyconfig = acymailing_config();
		$type['matukio'] = 'Matukio event';
		if(version_compare($acyconfig->get('version'), '4.9.4', '<')) return '<div id="filter__num__matukio">Please update AcyMailing, the Matukio plugin may not work properly with this version</div>';
		if(!$this->component_installed) return '<div id="filter__num__matukio">You must install Matukio to use this filter</div>';

		
		acymailing_loadLanguageFile('com_matukio', JPATH_SITE);
		acymailing_loadLanguageFile('com_matukio', JPATH_ADMINISTRATOR);

		$allEvents = acymailing_loadObjectList('SELECT id, title FROM #__matukio ORDER BY title ASC LIMIT 100');
		$eventList = array();
		if(!empty($allEvents)){
			foreach($allEvents as $oneEvent){
				$eventList[] = acymailing_selectOption($oneEvent->id, $oneEvent->title);
			}
		}else{
			$eventList[] = acymailing_selectOption('<OPTGROUP>', "No event");
			$eventList[] = acymailing_selectOption('</OPTGROUP>');
		}

		$paid = array();
		$paid[] = acymailing_selectOption('0', acymailing_translation('COM_MATUKIO_EVERYONE'));
		$paid[] = acymailing_selectOption('1', acymailing_translation('COM_MATUKIO_PAID'));
		$paid[] = acymailing_selectOption('2', acymailing_translation('COM_MATUKIO_UNPAID'));

		$statusNames = array();
		$statusNames[] = acymailing_selectOption('5', acymailing_translation('COM_MATUKIO_EVERYONE'));
		$statusNames[] = acymailing_selectOption('0', acymailing_translation('COM_MATUKIO_PENDING'));
		$statusNames[] = acymailing_selectOption('1', acymailing_translation('COM_MATUKIO_PARTICIPANT_ASSURED'));
		$statusNames[] = acymailing_selectOption('2', acymailing_translation('COM_MATUKIO_WAITLIST'));
		$statusNames[] = acymailing_selectOption('3', acymailing_translation('COM_MATUKIO_ARCHIVED'));
		$statusNames[] = acymailing_selectOption('4', acymailing_translation('COM_MATUKIO_DELETED'));

		$return = '<div id="filter__num__matukio">';
		$return .= acymailing_translation('COM_MATUKIO_EVENTS').' '.acymailing_select($eventList, 'filter[__num__][matukio][id]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br />'.acymailing_translation('COM_MATUKIO_PAID').' '.acymailing_select($paid, 'filter[__num__][matukio][paid]', 'style="width:100px;" class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br />'.acymailing_translation('COM_MATUKIO_STATUS').' '.acymailing_select($statusNames, 'filter[__num__][matukio][status]', 'style="width:150px;" class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br /><input type="text" name="filter[__num__][matukio][subdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:70px;" /> < '.acymailing_translation('COM_MATUKIO_DATE_OF_BOOKING').' < <input type="text" name="filter[__num__][matukio][subdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:70px;"/></div>';
		return $return;
	}

	function onAcyProcessFilterCount_matukio(&$query, $filter, $num){
		$this->onAcyProcessFilter_matukio($query, $filter, $num);
		return acymailing_translation_sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_matukio(&$query, $filter, $num){
		if(!$this->component_installed) return;

		if(!empty($filter['subdateinf'])){
			$filter['subdateinf'] = acymailing_replaceDate($filter['subdateinf']);
			if(!is_numeric($filter['subdateinf'])) $filter['subdateinf'] = strtotime($filter['subdateinf']);
			if(!empty($filter['subdateinf'])) $query->where[] = 'matukio_bookings'.$num.'.bookingdate > '.acymailing_escapeDB(date('Y-m-d H:i:s', $filter['subdateinf']));
		}

		if(!empty($filter['subdatesup'])){
			$filter['subdatesup'] = acymailing_replaceDate($filter['subdatesup']);
			if(!is_numeric($filter['subdatesup'])) $filter['subdatesup'] = strtotime($filter['subdatesup']);
			if(!empty($filter['subdatesup'])) $query->where[] = 'matukio_bookings'.$num.'.bookingdate < '.acymailing_escapeDB(date('Y-m-d H:i:s', $filter['subdatesup']));
		}

		$myquery = '#__matukio_bookings AS matukio_bookings'.$num.' ON matukio_bookings'.$num.'.email = sub.email';

		if(!empty($filter['paid'])){
			if($filter['paid'] == '1'){
				$myquery .= ' AND matukio_bookings'.$num.'.paid = 1';
			}else if($filter['paid'] == '2'){
				$myquery .= ' AND matukio_bookings'.$num.'.paid = 0';
			}
		}

		$query->join[] = $myquery;
		$query->where[] = 'matukio_bookings'.$num.'.semid = '.intval($filter['id']);

		if($filter['status'] != 5){
			$query->where[] = 'matukio_bookings'.$num.'.status = '.intval($filter['status']);
		}
	}
}//endclass
?>