<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingmijoevents extends JPlugin
{
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->name = 'mijoevents';
		if(!isset($this->params))
		{
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new JParameter( $plugin->params );
		}

		//check if the component is installed
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_mijoevents'))
		{
			$this->component_installed = false;
		}else{
			$this->component_installed = true;
		}
	}

	function acymailing_getPluginType()
	{
		$app = JFactory::getApplication();
		if(!$this->component_installed)
			return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'MijoEvents';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_mijoevents_show()
	{
		$config = acymailing_config();

		if($config->get('version') < '4.7.2'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_mijoevents',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		// don't forget to change the default order value if needed
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		$db = JFactory::getDBO();

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, c.title AS cattitle ' .
				'FROM #__mijoevents_events AS a ' .
				'JOIN #__mijoevents_event_categories AS b ON a.id = b.event_id ' .
				'JOIN #__mijoevents_categories AS c ON b.category_id = c.id ';

		//search fields...
		$searchFields = array('a.id','a.title','a.alias');

		//apply search fields
		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaypub','all') == 'onlypub')
		{
			$filters[] = 'a.published = 1';
		}

		//we hide past events but we remove one day just to make sure we won't hide something we should not!
		if($this->params->get('hidepastevents','yes') == 'yes')
		{
			$filters[] = 'a.`event_date` >= '.$db->Quote(date('Y-m-d',time() - 86400));
		}

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat))
			$filters[] = 'b.category_id = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		//apply ordering
		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$results = $db->loadObjectList();
		$rows = array();
		foreach($results as $result)
		{
			if(empty($rows[$result->id]))
				$rows[$result->id] = $result;
			else
				$rows[$result->id]->cattitle .= ' - '.$result->cattitle;
		}

		//yellow highlighting on search matches
		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(catid == 'all')
				{
					if(window.document.getElementById('cat'+catid).className == 'selectedrow')
					{
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid])
					{
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if(document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				<?php
					//add the custom fields the user wants to be displayed
				?>
				tmp = 0;
				for(var i=0; i < document.adminForm.customfields.length; i++)
				{
					if(document.adminForm.customfields[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| customFields:";
							 otherinfo += document.adminForm.customfields[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.customfields[i].value;
						 }
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '1')
					 {
						 otherinfo += '| link';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
					 	if(document.adminForm.pict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				<?php
					//add the custom fields the user wants to be displayed
				?>
				tmp = 0;
				for(var i=0; i < document.adminForm.customfieldsauto.length; i++)
				{
					if(document.adminForm.customfieldsauto[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| customFields:";
							 otherinfo += document.adminForm.customfieldsauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.customfieldsauto[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '1')
					{
						 otherinfo += '| link';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				tmp=0;
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						if(document.adminForm.autopict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value)
				{
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value)
				{
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value)
				{
					otherinfo += "| order:"+document.adminForm.contentorder.value;
				}

				if(document.adminForm.mindelayevent && document.adminForm.mindelayevent.value && document.adminForm.mindelayevent.value>0){ otherinfo += '| mindelay:'+document.adminForm.mindelayevent.value; }
				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ otherinfo += '| delay:'+document.adminForm.delayevent.value; }
				if(document.adminForm.from_date && document.adminForm.from_date.value){ otherinfo += '| from:'+document.adminForm.from_date.value; }
				if(document.adminForm.to_date && document.adminForm.to_date.value){ otherinfo += '| to:'+document.adminForm.to_date.value; }

				if(document.adminForm.min_article && document.adminForm.min_article.value)
				{
					otherinfo += "| min:"+document.adminForm.min_article.value;
				}

				if(window.document.getElementById('jlang')  && window.document.getElementById('jlang').value != '')
				{
					otherinfo += '| lang:'+window.document.getElementById('jlang').value;
				}

				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "event_date,DESC", JText::_('COM_MIJOEVENTS_EVENT_DATE'));
		$ordering[] = JHTML::_('select.option', "event_end_date,DESC", JText::_('COM_MIJOEVENTS_EVENT_END_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modified", JText::_('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'introtext', 'label' => 'INTRO_TEXT', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'date', 'label' => 'COM_MIJOEVENTS_EVENT_DATE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'endate', 'label' => 'COM_MIJOEVENTS_EVENT_END_DATE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'location', 'label' => 'COM_MIJOEVENTS_LOCATION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'capacity', 'label' => 'COM_MIJOEVENTS_CAPACITY', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'cutoffdate', 'label' => 'COM_MIJOEVENTS_CUT_OFF_DATE', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'indivprice', 'label' => 'COM_MIJOEVENTS_INDIVIDUAL_PRICE', 'checked' => '');

		$db->setQuery('SELECT name, title FROM #__mijoevents_fields WHERE published = 1 AND display_in = 2 AND field_type NOT LIKE "checkbox"'); //TODO: when checkbox field issues fixed, enable this type of field
		$customFields = $db->loadObjectList();

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i == 5)
						{
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.JText::_($oneField['label']).'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields))
				{
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam)
					{
						if($i == 5)
						{
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->name.'" name="customfields" id="cf_'.$oneParam->name.'" type="checkbox" onclick="updateTag();" /> ';
						echo '<label for="cf_'.$oneParam->name.'">'.$oneParam->title.'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'c.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					{
						foreach($rows as $row)
						{
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td>
									<?php
										if(!empty($row->title))
										{
											echo $row->title;
										}
									?>
								</td>
								<td>
									<?php
										if(!empty($row->cattitle))
										{
											echo $row->cattitle;
										}
									?>
								</td>
								<td align="center" style="text-align:center" >
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();

		// start category tab
		echo $tabs->startPanel( JText::_('UPCOMING_EVENTS'), $this->name.'_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i%5 == 0)
						{
							echo '</tr><tr><td/>';
							$i++;
						}
						if($i == 4)
						{
							$jflanguages = acymailing_get('type.jflanguages');
							$jflanguages->onclick = 'onchange="updateTagAuto();"';
							$jflanguages->jid = 'jlang';
							echo '<td>'.$jflanguages->displayJLanguages('jlang').'</td></tr><tr><td/>';
							$i += 2;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.JText::_($oneField['label']).'</label></td>';
						$i++;
					}
					while($i%5 != 0)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields))
				{
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam)
					{
						if($i == 5)
						{
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->name.'" name="customfieldsauto" id="cf_'.$oneParam->name.'auto" type="checkbox" onclick="updateTagAuto();" /> ';
						echo '<label for="cf_'.$oneParam->name.'auto">'.$oneParam->title.'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
				<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<tr>
				<?php if($type =='autonews'){ ?>
					<td>
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td>
					<td colspan="2">
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
				<?php } ?>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="<?php if($type =='autonews') echo 1; else echo 4;?>">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php echo JText::_('ACY_FROM_DATE'); ?>
				 </td>
				 <td colspan="2">
				 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('mindelayevent',0,3); ?>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('ACY_TO_DATE'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('delayevent',7776000,3); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td>
					<?php 	echo JText::_('ACY_FROM_DATE'); ?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('calendar', '', 'from_date','from_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto();')); ?>
				</td>
				<td>
					<?php 	echo JText::_('ACY_TO_DATE'); ?>
				</td>
				<td>
					<?php echo JHTML::_('calendar', '', 'to_date','to_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto();')); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
<?php $k=0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo JText::_('ACY_ALL');
				?>
				</td>
			</tr>
			<?php
			if(!empty($this->catvalues))
			foreach($this->catvalues as $oneCat)
			{
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	function _categories($filter_cat)
	{
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id,parent AS parent_id,title FROM #__mijoevents_categories ORDER BY id ASC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats))
			foreach($mosetCats as $oneCat)
				$this->cats[$oneCat->parent_id][] = $oneCat;

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=0,$level=0)
	{
		if(!empty($this->cats[$parent_id]))
		{
			foreach($this->cats[$parent_id] as $cat)
			{
				$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
				$this->_handleChildrens($cat->id,$level+1);
			}
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);

		if(empty($tags)) return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$lang = JFactory::getLanguage();
		$lang->load('com_mijoevents',JPATH_SITE);

		$db = JFactory::getDBO();
		$db->setQuery('SELECT name, title, field_type FROM #__mijoevents_fields WHERE display_in = 2');
		$this->customFields = $db->loadObjectList();
		$db->setQuery('SELECT lang_code, title FROM #__languages');
		$languages = $db->loadObjectList();
		$this->languages = array();
		foreach($languages as $lang)
		{
			$this->languages[$lang->lang_code] = $lang->title;
		}

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		if(!empty($tag->customFields)){
			$tag->customFields = explode(',',$tag->customFields);
			foreach($tag->customFields as $i => $oneDisplay){
				$tag->customFields[trim($oneDisplay)] = trim($oneDisplay);
			}
		}

		// load content
		$db = JFactory::getDBO();
		$query = 'SELECT a.*, b.address AS locaddress FROM #__mijoevents_events AS a ' .
				'JOIN #__mijoevents_locations AS b ' .
				'ON a.location_id = b.id ' .
				'WHERE a.id = '.intval($tag->id).' LIMIT 1';
		$db->setQuery($query);
		$content = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		if(!empty($content->fields)){
			$content->fields = (array) json_decode($content->fields);
			unset($varFields['{fields}']);
			foreach($content->fields as $i => $oneCF)
				$varFields['{'.$i.'}'] = $oneCF;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_mijoevents&view=event&event_id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title))
		{
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(!empty($tag->link))
				$result .= '<a href="'.$link.'">';
			$result .= $content->title;
			if(!empty($tag->link))
				$result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		// display the main text wraped or not
		if(!( (empty($tag->introtext) || empty($content->introtext)) && (empty($tag->description) || empty($content->fulltext)) && (empty($tag->image) || empty($content->thumb)) ))
		{
			$result .= '<tr><td colspan="2">';
			if(!empty($tag->image) && !empty($content->thumb))
			{
				if(!empty($tag->link)) $result .= '<a href="'.$link.'">';
				$pict = '<img src="media/com_mijoevents/images/'.$content->thumb.'" alt="'.str_replace('"','\"',$content->title).'" style="float:left;padding-right:5px;"/>';
				$result .= $pict;
				$varFields['{imagehtml}'] = $pict;
				if(!empty($tag->link)) $result .= '</a>';
			}
			$text = '';
			if(!empty($tag->introtext) && !empty($content->introtext))
				$text .= $content->introtext;
			if(!empty($tag->description) && !empty($content->fulltext))
				$text .= $content->fulltext;
			if(!empty($text))
				$result .= $acypluginsHelper->wrapText($text, $tag);
			$result .= '</td></tr>';
		}

		if(!empty($tag->date) && !empty($content->event_date))
		{
			$result .= '<tr><td nowrap>'.JText::_('COM_MIJOEVENTS_EVENT_DATE').'</td><td>: '.acymailing_getDate(acymailing_getTime($content->event_date), 'DATE_FORMAT_LC').'</td></tr>';
		}

		if(!empty($tag->endate) && !empty($content->event_end_date))
		{
			$result .= '<tr><td nowrap>'.JText::_('COM_MIJOEVENTS_EVENT_END_DATE').'</td><td>: '.acymailing_getDate(acymailing_getTime($content->event_end_date), 'DATE_FORMAT_LC').'</td></tr>';
		}

		if(!empty($tag->location) && !empty($content->locaddress))
		{
			$result .= '<tr><td nowrap valign="top">'.JText::_('COM_MIJOEVENTS_LOCATION').'</td><td>: '.$content->locaddress.'</td></tr>';
		}

		if(!empty($tag->capacity) && isset($content->event_capacity))
		{
			$result .= '<tr><td nowrap>'.JText::_('COM_MIJOEVENTS_CAPACITY').'</td><td>: '.((empty($content->event_capacity)) ? JText::_('COM_MIJOEVENTS_UNLIMITED') : $content->event_capacity).'</td></tr>';
		}

		if(!empty($tag->cutoffdate) && !empty($content->cut_off_date))
		{
			$result .= '<tr><td nowrap>'.JText::_('COM_MIJOEVENTS_CUT_OFF_DATE').'</td><td>: '.acymailing_getDate(acymailing_getTime($content->cut_off_date), 'DATE_FORMAT_LC').'</td></tr>';
		}

		if(!empty($tag->indivprice) && !empty($content->individual_price))
		{
			$result .= '<tr><td nowrap>'.JText::_('COM_MIJOEVENTS_INDIVIDUAL_PRICE').'</td><td>: '.$content->individual_price.$content->currency_symbol.'</td></tr>';
		}

		foreach($this->customFields as $oneCF)
		{
			$name = $oneCF->name;
			if(!empty($tag->customFields[$name]) && !empty($content->fields[$name]))
			{
				if($oneCF->field_type == 'language')
					$result .= '<tr><td nowrap>'.$oneCF->title.'</td><td>: '.$this->languages[$content->fields[$name]].'</td></tr>';
				elseif($oneCF->field_type == 'calendar')
					$result .= '<tr><td nowrap>'.$oneCF->title.'</td><td>: '.acymailing_getDate(acymailing_getTime($content->fields[$name]), 'DATE_FORMAT_LC').'</td></tr>';
				elseif($oneCF->field_type == 'multilist' || $oneCF->field_type == 'checkbox')
					$result .= '<tr><td nowrap>'.$oneCF->title.'</td><td>: '.(is_array($content->fields[$name]) ? implode(', ', $content->fields[$name]) : $content->fields[$name]).'</td></tr>';
				else
					$result .= '<tr><td nowrap>'.$oneCF->title.'</td><td>: '.$content->fields[$name].'</td></tr>';
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(!empty($tag->readmore)) $result .= '<tr><td colspan="2">'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$pictureHelper = acymailing_get('helper.acypict');
		if(isset($tag->pict))
		{
			if($tag->pict == 'resized')
			{
				$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}else{
			$result = $pictureHelper->removePictures($result);
		}
		return $result;
	}

	function _replaceAuto(&$email)
	{
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);

			if(!empty($email->altbody))
				$email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);

			foreach($this->tags as $tag => $result)
			{
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags))
		{
			return $return;
		}

		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;
			if(empty($parameter->from))
				$parameter->from = date( 'Y-m-d H:i:s',$time);
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat)
			{
				if(empty($oneCat))
					continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT DISTINCT a.id FROM #__mijoevents_events AS a JOIN #__mijoevents_event_categories AS b ON a.id = b.event_id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea))
			{
				$where[] = 'b.category_id IN ('.implode(',',$selectedArea).')';
			}

			// Only published content
			$where[] = 'a.published = 1';

			if(!empty($parameter->addcurrent))
			{
				//not finished and next events
				if(!empty($parameter->mindelay))
					$where[] = 'a.`event_end_date` >= '.$db->Quote(date('Y-m-d H:i:s', $time+$parameter->mindelay));
				else
					$where[] = 'a.`event_end_date` >= '.$db->Quote($parameter->from);
			}else{
				//not started events
				if(!empty($parameter->mindelay))
					$where[] = 'a.`event_date` >= '.$db->Quote(date('Y-m-d H:i:s', $time+$parameter->mindelay));
				else
					$where[] = 'a.`event_date` >= '.$db->Quote($parameter->from);
			}

			//should we display only events starting in the sending day ?
			if(!empty($parameter->todaysevent))
			{
				$where[] = 'a.`event_date` <= '.$db->Quote(date('Y-m-d 23:59:59', $time));
			}

			if(!empty($parameter->delay)) $where[] = 'a.`event_date` <= '.$db->Quote(date('Y-m-d H:i:s', $time+$parameter->delay));
			if(!empty($parameter->to)) $where[] = 'a.`event_date` <= '.$db->Quote($parameter->to);
			if(!empty($parameter->lang)) $where[] = 'a.language = '.$db->Quote($parameter->lang);

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order))
			{
				if($parameter->order == 'rand')
				{
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max))
				$query .= ' LIMIT '.intval($parameter->max);
			else
				$query .= ' LIMIT 20'; // limit, because we do not want to display one bilion contents in the newsletter...

			// load content IDs
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min)
			{
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles))
			{
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(!empty($parameter->customFields)) $args[] = 'customFields:'.$parameter->customFields;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>