<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingRedevent extends JPlugin
{

	var $searchFields = array('b.id','a.title','a.alias','b.title');
	var $selectedFields = array('a.*','b.dates','b.id','b.title','a.title as eventtitle');

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'redevent');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	 function acymailing_getPluginType() {

	 	$onePlugin = new stdClass();
	 	$onePlugin->name = JText::_('JOOMEXT_EVENT'). ' <small>(redEvent)</small>';
	 	$onePlugin->function = 'acymailingredevent_show';
	 	$onePlugin->help = 'plugin-redevent';

	 	return $onePlugin;
	 }

	 function acymailingredevent_show(){
		$app = JFactory::getApplication();

		$pageInfo = null;

		$paramBase = ACYMAILING_COMPONENT.'.tagredevent';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'b.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		$db = JFactory::getDBO();

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$this->searchFields)." LIKE $searchVal";
		}

		//we hide past events but we remove one day just to make sure we won't hide something we should not!
		if($this->params->get('hidepastevents','yes') == 'yes'){
			$filters[] = "b.`dates` >= ".$db->Quote(date('Y-m-d',time() - 86400));
		}

		$whereQuery = '';
		if(!empty($filters)){
			$whereQuery = ' WHERE ('.implode(') AND (',$filters).')';
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS '.implode(',',$this->selectedFields).' FROM `#__redevent_event_venue_xref` as b LEFT JOIN `#__redevent_events` as a ON b.eventid = a.id';
		if(!empty($whereQuery)) $query.= $whereQuery;
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'redevent_tab');
		echo $tabs->startPanel( JText::_( 'JOOMEXT_EVENT' ), 'redevent_event');
	?>
		<br style="font-size:1px"/>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">

				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php
						echo JHTML::_('grid.sort', JText::_('FIELD_DATE'), 'b.dates', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort',   JText::_('ACY_ID'), 'b.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="3">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->id?>" class="<?php echo "row$k"; ?>" onclick="setTag('{redevent:<?php echo $row->id; ?>}');insertTag();" style="cursor:pointer;">
						<td>
						<?php echo $row->eventtitle;
						if(!empty($row->eventtitle) && !empty($row->title))  echo ' - ';
						echo $row->title;?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo JHTML::_('date',strtotime($row->dates),JText::_('DATE_FORMAT_LC')); ?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php
	echo $tabs->endPanel();
	echo $tabs->startPanel( JText::_( 'UPCOMING_EVENTS' ), 'redevent_auto');
	$type = JRequest::getString('type');

	$db->setQuery('SELECT a.* FROM `#__redevent_categories` as a ORDER BY a.`ordering` ASC');
	$categories = $db->loadObjectList('id');

	?>
	<br style="font-size:1px"/>
	<script language="javascript" type="text/javascript">
		<!--
			var selectedCat = new Array();
			function applyAutoEvent(catid,rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('event_cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('event_cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'event';
				}

				updateTag();
			}

			function updateTag(){
				tag = '{autoredevent:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'event'){
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				if(document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ tag += '|delay:'+document.adminForm.delayevent.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
	</script>
	<table width="100%" class="adminform">
		<tr>
			<td>
			<?php echo JText::_('MAX_ARTICLE'); ?>
			 </td>
			 <td>
			 	<input type="text" name="max_article" style="width:50px" value="" onchange="updateTag();"/>
			</td>
			<td>
			<?php echo JText::_('MAX_STARTING_DATE'); ?>
			 </td>
			 <td>
			 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTag();"; echo $delayType->display('delayevent',7776000,3); ?>
			</td>
		</tr>
		<?php if($type == 'autonews') { ?>
		<tr>
			<td>
			<?php 	echo JText::_('MIN_ARTICLE'); ?>
			 </td>
			 <td>
			 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateTag();"/>
			</td>
			<td>
			 </td>
			 <td>
			</td>
		</tr>
		<?php } ?>
	</table>
	<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
	<?php $k=0; foreach($categories as $oneCat){ ?>
		<tr id="event_cat<?php echo $oneCat->id ?>" class="<?php echo "row$k"; ?>" onclick="applyAutoEvent(<?php echo $oneCat->id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
			<td>
			<?php
				if(!empty($oneCat->parent_id)) echo $categories[$oneCat->parent_id]->catname.' => ';
				echo $oneCat->catname;
			?>
			</td>
		</tr>
	<?php $k = 1 - $k; } ?>
	</table>
	<?php
	echo $tabs->endPanel();
	echo $tabs->endPane();

	//End of the function
	 }

	 function acymailing_replacetags(&$email,$send = true){
	 	$this->_replaceAuto($email);
	 	$this->_replaceEvents($email);
	 }

	 function _replaceEvents(&$email){
		$match = '#{redevent:(.*)}#Ui';
		$variables = array('body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'helper.php');

		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'classes'.DS.'image.class.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'classes'.DS.'output.class.php');

		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'tags.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'models'.DS.'eventhelper.php');

		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'route.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'log.php');

		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'route.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'recurrence.php');

		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'helpers'.DS.'customfields.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'classes'.DS.'user.class.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'classes'.DS.'useracl.class.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'classes'.DS.'attendee.class.php');
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redevent'.DS.'classes'.DS.'attachment.class.php');
		// redform
		@include_once(ACYMAILING_ROOT.'components'.DS.'com_redform'.DS.'redform.core.php');

		if(!class_exists('JSite')) include_once(ACYMAILING_ROOT.'includes'.DS.'application.php');



		$mailerHelper = acymailing_get('helper.mailer');

		$resultshtml = array();
		$resultstext = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($resultshtml[$oneTag])) continue;

				$resultshtml[$oneTag] = $this->_replaceEvent($allresults[1][$i]);
				$resultstext[$oneTag] = $mailerHelper->textVersion($resultshtml[$oneTag]);
			}
		}

		$email->body = str_replace(array_keys($resultshtml),$resultshtml,$email->body);
		$email->altbody = str_replace(array_keys($resultstext),$resultstext,$email->altbody);
	 }

	 function _replaceEvent($id){

		//1 : Load the informations of the product...
		$query = 'SELECT g.*, b.*, a.*,d.*, a.title as eventtitle FROM `#__redevent_event_venue_xref` as d ';
		$query .= 'LEFT JOIN `#__redevent_events` AS a ON d.`eventid` = a.id ';
		$query .= 'LEFT JOIN `#__redevent_venues` AS b ON d.`venueid` = b.id ';
		$query .= 'LEFT JOIN `#__redevent_groups` AS g ON d.`groupid` = g.id ';
		$query .= 'WHERE d.id = '.(int) $id.' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$event = $db->loadObject();

		if(empty($event)){
			$app = JFactory::getApplication();
			if($app->isAdmin()){
				$app->enqueueMessage('The event "'.$id.'" could not be loaded','notice');
			}
			return '';
		}

		JRequest::setVar('xref',$id);
		$tags = new redEVENT_tags();
		if(method_exists($tags,'setXref')) $tags->setXref($id);
		if(method_exists($tags,'setEventId')) $tags->setEventId($event->eventid);

		$link = acymailing_frontendLink('index.php?option=com_redevent&view=details&xref='.$id.'&id='.$event->eventid.':'.str_replace(' ','-',$event->alias));

		//Check if the template exists...
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'redevent.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'redevent.php');
			return ob_get_clean();
		}

		$result = '<div class="acymailing_content">';
		$title = $event->eventtitle;
		if(!empty($title) && !empty($event->title)) $title .= ' - ';
		$title .= $event->title;

		$result .= '<a style="text-decoration:none;" name="event-'.$event->id.'" target="_blank" href="'.$link.'"><h2 class="acymailing_title">'.$title.'</h2></a>';
		//Replace the event description
		//Remove the [venues] tag, it does not work and we don't want it anyway
		$template = $this->params->get('template');
		if(empty($template)) $template = $event->datdescription;
		$result .= $tags->ReplaceTags(str_replace('[venues]','',$template));
		$result .= '</div>';

		return $result;

	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
		}
	}

	function acymailing_generateautonews(&$email){

		$return = null;
		$return->status = true;
		$return->message = '';

		$time = time();
		//Check if we should generate the autoNewsletter or not...
		$match = '#{autoredevent:(.*)}#Ui';
		$variables = array('body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|',$allresults[1][$i]);
				//The first argument is a list of sections and cats...
				$allcats = explode('-',$arguments[0]);
				$parameter = null;
				for($i=1;$i<count($arguments);$i++){
					$args = explode(':',$arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int) $oneCat;
				}

				$query = 'SELECT venuexref.id FROM `#__redevent_event_venue_xref` as venuexref ';
				$query .= 'LEFT JOIN `#__redevent_event_category_xref` as catxref on venuexref.`eventid` = catxref.`event_id` ';
				$query .= 'LEFT JOIN `#__redevent_events` as event on event.id = venuexref.`eventid` ';

				$where = array();
				if(!empty($selectedArea)){
					$where[] = 'catxref.`category_id` IN ('.implode(',',$selectedArea).')';
				}

				$where[] = 'event.`published` = 1';
				$where[] = 'venuexref.`published` = 1';
				$where[] = 'venuexref.`dates` >= '.$db->Quote(date( 'Y-m-d',$time));
				if(!empty($parameter->delay)) $where[] = 'venuexref.`dates` <= '.$db->Quote(date( 'Y-m-d',$time + $parameter->delay));

				$query .= ' WHERE ('.implode(') AND (',$where).')';
				$query .= ' ORDER BY venuexref.`dates` ASC, venuexref.`times` ASC';
				if(!empty($parameter->max)) $query .= ' LIMIT '.(int) $parameter->max;

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) AND count($allArticles)< $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoredevent.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autoredevent.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$stringTag .= '<table cellspacing="0" cellpadding="0" border="0">';
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'redevent:'.$oneArticleId;
							$stringTag .= '{'.implode('|',$args).'}';
							$stringTag .= '</td></tr>';
						}
						$stringTag .= '</table>';
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}
}//endclass