<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingregistrationpro extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'registrationpro');
			$this->params = new acyParameter( $plugin->params );
		}

		$this->erp_installed = file_exists(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_registrationpro');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
		 if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;
		 $onePlugin = new stdClass();
		 $onePlugin->name = 'Event Registration Pro';
		 $onePlugin->function = 'acymailing_registrationpro_show';
		 $onePlugin->help = 'plugin-registrationpro';
		 return $onePlugin;
	}

	function acymailing_registrationpro_show(){
		$config = acymailing_config();
		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}
		$app = JFactory::getApplication();

		$langerp = JFactory::getLanguage();
		$langerp->load('com_registrationpro',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.registrationpro';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		$db = JFactory::getDBO();

		$searchFields = array('a.id','a.titel','b.id','b.catname');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayevt','all') == 'onlypub') $filters[] = "a.published = 1";

		if(!empty($pageInfo->filter_cat)) $filters[] = "a.catsid = ".$pageInfo->filter_cat;

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.*, a.id AS evtid FROM `#__registrationpro_dates` AS a ';
		$query .= 'JOIN #__registrationpro_categories AS b ON a.catsid = b.id ';

		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				if(selectedContents[contentid])
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(selectedCat[catid])
				{
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbaffiche.length; i++)
				{
					if (document.adminForm.cbaffiche[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "|display:";
							 otherinfo += document.adminForm.cbaffiche[i].value;
						 }else{
							 otherinfo += ",";
							 otherinfo += document.adminForm.cbaffiche[i].value;
						 }
					}
				}

				if(document.adminForm.extrafields)
				{
					tmp=0;
					for(var i=0; i < document.adminForm.extrafields.length; i++)
					{
						if (document.adminForm.extrafields[i].checked)
						{
							if(tmp==0)
							{
								tmp+=1;
								otherinfo += "| extrafields:";
								otherinfo += document.adminForm.extrafields[i].value;
							}else{
								otherinfo += ",";
								 otherinfo += document.adminForm.extrafields[i].value;
							}
						}
					}
				}

				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if (document.adminForm.clickable[i].checked)
					 {
						 otherinfo += '| clickable:'+document.adminForm.clickable[i].value;
					 }
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked)
					 {
						 otherinfo += '| readmore:'+document.adminForm.readmore[i].value;
					 }
				}

				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					 if (document.adminForm.pict[i].checked)
					 {
						 otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						 }else{
							 document.getElementById('pictsize').style.display = 'none';
						 }
					}
				}
				for(var i in selectedContents)
				{
					if(selectedContents[i] == 'content')
					{
						tag = tag + '{registrationpro:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbafficheauto.length; i++)
				{
					if (document.adminForm.cbafficheauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbafficheauto[i].value;
						 }else{
							 otherinfo += ",";
							 otherinfo += document.adminForm.cbafficheauto[i].value;
						 }
					}
				}

				if(document.adminForm.extrafieldsauto)
				{
					tmp=0;
					for(var i=0; i < document.adminForm.extrafieldsauto.length; i++)
					{
						if (document.adminForm.extrafieldsauto[i].checked)
						{
							if(tmp==0)
							{
								tmp+=1;
								otherinfo += "| extrafields:";
								otherinfo += document.adminForm.extrafieldsauto[i].value;
							}else{
								otherinfo += ",";
								 otherinfo += document.adminForm.extrafieldsauto[i].value;
							}
						}
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked)
					{
						 otherinfo += '| clickable:'+document.adminForm.clickableauto[i].value;
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked)
					 {
						 otherinfo += '| readmore:'+document.adminForm.readmoreauto[i].value;
					 }
				}

				tmp=0;
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						 otherinfo += '| pict:'+document.adminForm.autopict[i].value;
						if(document.adminForm.autopict[i].value == 'resized')
						{
							 document.getElementById('pictsizeauto').style.display = '';
							 if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							 if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						 }else{
							 document.getElementById('pictsizeauto').style.display = 'none';
						 }
					}
				}

				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ otherinfo += '| delay:'+document.adminForm.delayevent.value; }
				if(document.adminForm.from_date && document.adminForm.from_date.value){ otherinfo += '| from:'+document.adminForm.from_date.value; }
				if(document.adminForm.to_date && document.adminForm.to_date.value){ otherinfo += '| to:'+document.adminForm.to_date.value; }
				if(document.adminForm.cols.value){ otherinfo += "| cols:"+document.adminForm.cols.value; }
				if(document.adminForm.max_article.value){ otherinfo += "| max_article:"+document.adminForm.max_article.value; }
				if(document.adminForm.contentorder.value){ otherinfo += "| order:"+document.adminForm.contentorder.value; }
				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){ otherinfo += "| min_article:"+document.adminForm.min_article.value; }
				<?php } ?>
				tag = '{autoregistrationpro:';
				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}
				tag+=otherinfo+'}<br />';
				setTag(tag);
			}
		//-->
		</script>
<?php
		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "dates,DESC",JText::_('ADMIN_COUPONS_START_DATE_FILTER'));
		$ordering[] = JHTML::_('select.option', "enddates,DESC",JText::_('ADMIN_COUPONS_END_DATE_FILTER'));
		$ordering[] = JHTML::_('select.option', "titel,ASC",JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand",JText::_('ACY_RANDOM'));

		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "",JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created",JText::_('ONLY_NEW_CREATED'));

		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'registrationpro_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'registrationpro_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_TITEL'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="shortdesc" id="shortdesc" onclick="updateTag();"/><label style="margin-left:5px" for="shortdesc" id="shortdesc-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_SHORT_DESCR'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="description" id="description" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="description" id="description-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="terms" id="terms" onclick="updateTag();"/><label style="margin-left:5px" for="terms" id="terms-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_TERMS_AND_CONDITION'),':');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="hourstart" id="hourstart" onclick="updateTag();"/><label style="margin-left:5px" for="hourstart" id="hourstart-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_DATE_START'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="hourstop" id="hourstop" onclick="updateTag();"/><label style="margin-left:5px" for="hourstop" id="hourstop-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_DATE_END'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="registrationstart" id="registrationstart" onclick="updateTag();"/><label style="margin-left:5px" for="registrationstart" id="registrationstart-lbl"><?php echo JText::_('ADMIN_EVENTS_REG').' '.JText::_('ADMIN_EVENTS_DATE_START'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="registrationstop" id="registrationstop" onclick="updateTag();"/><label style="margin-left:5px" for="registrationstop" id="registrationstop-lbl"><?php echo JText::_('ADMIN_EVENTS_REG').' '.JText::_('ADMIN_EVENTS_DATE_END'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbaffiche" value="location" id="location" onclick="updateTag();"/><label style="margin-left:5px" for="location" id="location-lbl"><?php echo JText::_('EVENTS_CLUB');?></label></td>
				<td nowrap="nowrap" colspan="3"><input type="checkbox" name="cbaffiche" value="price" id="price" onclick="updateTag();"/><label style="margin-left:5px" for="price" id="price-lbl"><?php echo JText::_('EVENT_TICKETS_HEAD_TICKET_PRICE');?></label></td>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="3"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
<!-- ===============================================================================REDIM IMAGE==================================================================================== -->
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
<!--====================================================================================LISTE DOCUMENTS===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.titel', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.catname', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					foreach($rows as $row)
					{
				?>
					<tr id="content<?php echo $row->evtid; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->evtid.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->titel;
							echo acymailing_tooltip($text, $row->titel, '', $row->titel);
						?>
						</td>
						<td>
						<?php
							if(!empty($row->catname))
							{
								$text = '<b>'.JText::_('TAG_CATEGORIES',true).' : </b>'.$row->catname;
								echo acymailing_tooltip($text, $row->catname, '', $row->catname);
							}
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php
								echo $row->evtid;
							?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'registrationpro_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_TITEL'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="shortdesc" id="shortdescauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="shortdescauto" id="shortdescauto-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_SHORT_DESCR'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="description" id="descriptionauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="descriptionauto" id="descriptionauto-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="terms" id="termsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="termsauto" id="termsauto-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_TERMS_AND_CONDITION'),':');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="hourstart" id="hourstartauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="hourstartauto" id="hourstartauto-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_DATE_START'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="hourstop" id="hourstopauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="hourstopauto" id="hourstopauto-lbl"><?php echo trim(JText::_('ADMIN_EVENTS_DATE_END'),':');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="registrationstart" id="registrationstartauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="registrationstartauto" id="registrationstartauto-lbl"><?php echo JText::_('ADMIN_EVENTS_REG').' '.JText::_('ADMIN_EVENTS_DATE_START'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="registrationstop" id="registrationstopauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="registrationstopauto" id="registrationstopauto-lbl"><?php echo JText::_('ADMIN_EVENTS_REG').' '.JText::_('ADMIN_EVENTS_DATE_END'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbafficheauto" value="location" id="locationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="locationauto" id="locationauto-lbl"><?php echo JText::_('EVENTS_CLUB');?></label></td>
				<td nowrap="nowrap" colspan="3"><input type="checkbox" name="cbafficheauto" value="price" id="priceauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="priceauto" id="priceauto-lbl"><?php echo JText::_('EVENT_TICKETS_HEAD_TICKET_PRICE');?></label></td>
			</tr>
			<tr>
				<td nowrap="nowrap" colspan="3"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
				<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>

			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td colspan="2">
				 	<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('MAX_STARTING_DATE'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('delayevent',7776000,3); ?>
				</td>
			</tr>
			<?php }else{ ?>
				<tr>
				<td>
				<?php 	echo JText::_('ACY_FROM_DATE'); ?>
				</td>
				 <td colspan="2">
				<?php echo JHTML::_('calendar', '', 'from_date','from_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto();')); ?>
				</td>
				<td>
				<?php 	echo JText::_('ACY_TO_DATE'); ?>
				 </td>
				 <td>
				 <?php echo JHTML::_('calendar', '', 'to_date','to_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto();')); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
<?php $k=0;
			if(!empty($this->catvalues))
			foreach($this->catvalues as $oneCat)
			{
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id,parentid AS parent_id,catname AS name FROM #__registrationpro_categories ORDER BY `id` ASC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats))
		foreach($mosetCats as $oneCat)
		{
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=0,$level=0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->name);
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$match = '#{registrationpro:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}
		//If we didn't find anything...
		if(!$found) return;
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults)
		{
			foreach($allresults[0] as $i => $oneTag)
			{
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;
				$content = $this->_replaceContent($allresults,$i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content,true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	}

	function _replaceContent(&$results,$i){
		$langdjcf = JFactory::getLanguage();
		$langdjcf->load('com_registrationpro',JPATH_SITE);

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$arguments = explode('|',strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = intval($arguments[0]);
		for($i=1,$a=count($arguments);$i<$a;$i++)
		{
			$args = explode(':',$arguments[$i]);
			$arg0 = trim($args[0]);
			if(empty($arg0)) continue;
			if(isset($args[1]))
			{
				$tag->$arg0 = $args[1];
			}else{
				$tag->$arg0 = true;
			}
		}

		if(!empty($tag->display))
		{
			$tmp=explode(',',strip_tags($tag->display));
			foreach($tmp as $onetmp)
			{
				$tag->$onetmp=true;
			}
		}
		//2 : Load the article
		$query = 'SELECT c.*, b.*, a.*, a.id AS artid FROM `#__registrationpro_dates` AS a ' .
				 'JOIN #__registrationpro_locate AS b ' .
				 'ON a.locid = b.id '.
				 'JOIN #__registrationpro_categories AS c ' .
				 'ON a.catsid = c.id ';
		$query .= 'WHERE a.id = '.intval($tag->id);

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();
		$varFields = array();
		foreach($article as $alias => $value)
		{
			$varFields['{'.$alias.'}'] = $value;
		}

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();
		$result = '';
		//In case of we could not load the article for any reason...
		$app = JFactory::getApplication();
		if(empty($article))
		{
			if($app->isAdmin())
			{
				$app->enqueueMessage('The item "'.$tag->id.'" could not be loaded','notice');
			}
			return $result;
		}
		$link = 'index.php?option=com_registrationpro&view=event&did='.$tag->id;


		$result = '<div class="acymailing_content" ><table cellspacing="0" cellpadding="5" border="0" width="100%">';
		//Add the title with a link or not on it.
		$styleTitle = '<br /><h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';
		$resultTitle = '';
		if(!empty($tag->title))
		{
			if(!empty($tag->clickable))
			{
				$result .= '<tr><td colspan="2"><a href="'.$link.'" target="_blank" >'.$styleTitle.$article->titel.$styleTitleEnd.'</a></td></tr>';
			}else{
				$result .= '<tr><td colspan="2">'.$styleTitle.$article->titel.$styleTitleEnd.'</td></tr>';
			}
		}
		//TODO: when new version of AcyMailing, add a test with the hour format of ERP (it can be 12 hour format)
		$formattime = '%H:%M';
		/*
		require_once(JPATH_SITE.DS.'modules'.DS.'mod_registrationpro_minicalendar'.DS.'helper.php');
		$ERPparams = modRegistrationproMinicalendarHelper::GetRegproconfig();
		$formattime = $ERPparams['formattime'];
		*/
		if(!empty($tag->registrationstart) || !empty($tag->registrationstop))
		{
			$tmp = array();
			if(!empty($tag->registrationstart))
				$tmp[] = acymailing_getDate(acymailing_getTime($article->regstart),'%d %B %Y').' '.acymailing_getDate(acymailing_getTime($article->regstarttimes),$formattime);
			if(!empty($tag->registrationstop))
				$tmp[] = 'End : '.acymailing_getDate(acymailing_getTime($article->regstop),'%d %B %Y').' '.acymailing_getDate(acymailing_getTime($article->regstoptimes),$formattime);
			$result .= '<tr><td>'.JTEXT::_('ADMIN_EVENTS_DEFAULT_PRODUCT').'</td><td> '.implode(' ', $tmp).'</td></tr>';
		}
		if(!empty($tag->location))
		{
			$result .= '<tr><td>'.JTEXT::_('EVENTS_WHERE').'</td><td> ';
			$tmp = array();
			if(!empty($article->url))
			{
				$tmp[] = '<a href="'.$article->url.'">'.$article->club.'</a>';
			}else{
				$tmp[] = $article->club;
			}
			if(!empty($article->street))
			{
				$tmp[] = $article->street;
			}
			if(!empty($article->city) && !empty($article->country))
			{
				$tmp[] = $article->city.' ('.$article->country.')';
			}elseif(!empty($article->city)){
				$tmp[] = $article->city;
			}elseif(!empty($article->country)){
				$tmp[] = '('.$article->country.')';
			}
			$result .= implode(', ',$tmp).'.';
			$result .= '</td></tr>';
			if(!empty($article->locdescription))
			{
				$result .= '<tr><td/><td>'.$article->locdescription.'</td></tr>';
			}
		}
		if(!empty($tag->hourstart) || !empty($tag->hourstop))
		{
			$tmp = array();
			if(!empty($tag->hourstart))
				$tmp[] = acymailing_getDate(acymailing_getTime($article->dates),'%d %B %Y');
			if(!empty($tag->hourstop))
				$tmp[] = 'End : '.acymailing_getDate(acymailing_getTime($article->enddates),'%d %B %Y');
			$result .= '<tr><td>'.JTEXT::_('EVENTS_START_END_DATE').'</td><td> '.implode(' ', $tmp).'</td></tr>';
			$tmp = array();
			if(!empty($tag->hourstart))
				$tmp[] = acymailing_getDate(acymailing_getTime($article->times),$formattime);
			if(!empty($tag->hourstop))
				$tmp[] = 'End : '.acymailing_getDate(acymailing_getTime($article->endtimes),$formattime);
			$result .= '<tr><td>'.JTEXT::_('EVENTS_START_END_TIME').'</td><td> '.implode(' ', $tmp).'</td></tr>';
		}

		if(!empty($tag->shortdesc))
		{
			$result .= '<tr><td colspan="2">'.$article->shortdescription.'</td></tr>';
		}
		if(!empty($tag->description) && !empty($article->datdescription))
		{
			if(!empty($tag->wrap))
			{
				$wordwrap = intval($tag->wrap);
				if(!empty($wordwrap))
				{
					$newintrotext = strip_tags($article->datdescription,'<br>');
					$numChar = strlen($newintrotext);
					if($numChar > $wordwrap)
					{
						$stop = strlen($newintrotext);
						for($i=$wordwrap ; $i<$numChar ; $i++)
						{
							if($newintrotext[$i] == " ")
							{
								$stop = $i;
								break;
							}
						}
						$article->datdescription = substr($newintrotext,0,$stop).'...';
					}
				}
			}
			$result .= '<tr><td colspan="2"><b>'.JTEXT::_('EVENTS_DESC').'</b></td></tr>';
			$result .= '<tr><td colspan="2">'.$article->datdescription.'</td></tr>';
		}
		if(!empty($tag->price))
		{
			$query = 'SELECT total_price FROM #__registrationpro_payment WHERE regpro_dates_id = '.intval($tag->id).' LIMIT 1';
			$db->setQuery($query);
			$price = $db->loadObject();
			if(!empty($price))
			{
				$result .= '<tr><td>'.JTEXT::_('EVENTS_SEARCH_EVENT_PRICE').'</td><td>'.$price->total_price.'</td></tr>';
			}
		}

		if(!empty($tag->terms) && !empty($article->terms_conditions))
		{
			$result .= '<tr><td>'.JTEXT::_('ADMIN_EVENTS_TERMS_AND_CONDITION').'</td><td>'.$article->terms_conditions.'</td></tr>';
		}

		$pictureHelper = acymailing_get('helper.acypict');
		if(isset($tag->pict) && $tag->pict == '0')
		{
			$result = $pictureHelper->removePictures($result);
		}

		if(!empty($tag->readmore))
		{
			$readMoreText = empty($this->readmore) ? JText::_('JOOMEXT_READ_MORE') : $this->readmore;
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a></td></tr>';
		}

		$result = '<div class="acymailing_content" ><table cellspacing="0" cellpadding="0" border="0" width="100%">'.$result.'</table></div>';

		//in case of the user created his template
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'registrationpro.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'registrationpro.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		$result = $acypluginsHelper->removeJS($result);
		if(isset($tag->pict))
		{
			$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
			if($tag->pict == 'resized')
			{
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result)
			{
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$time = time();
		//Check if we find some tags
		$match = '#{autoregistrationpro:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}
		//If we didn't find anything... so we won't generate
		if(!$found) return $return;
		$this->tags = array();
		$db = JFactory::getDBO();
		foreach($results as $var => $allresults)
		{
			foreach($allresults[0] as $i => $oneTag)
			{
				if(isset($this->tags[$oneTag])) continue;
				//we search the caracteristics of the tag
				$arguments = explode('|',strip_tags($allresults[1][$i]));
				//The first argument is a list of cats
				$allcats = explode('-',$arguments[0]);
				$parameter = new stdClass();
				for($i=1 ; $i<count($arguments) ; $i++)
				{
					$args = explode(':',$arguments[$i]);
					$arg0 = trim($args[0]);
					if(isset($args[1]))
					{
						$parameter->$arg0 = trim($args[1]);
					}else{
						$parameter->$arg0 = true;
					}
				}
				//we load the documents according to the tag
				$selectedArea = array();
				foreach($allcats as $oneCat)
				{
					if(empty($oneCat)) continue;
					$selectedArea[] = intval($oneCat);
				}
				$query = 'SELECT id FROM #__registrationpro_dates';
				$where = array();

				if(!empty($selectedArea))
				{
					$where[] = 'catsid IN ('.implode(',',$selectedArea).')';
				}

				$where[] = "published = 1";
				$where[] = "dates >= ".$db->Quote(date( 'Y-m-d',$time));

				if(!empty($parameter->mindelay)) $where[] = 'dates >= '.$db->Quote(date( 'Y-m-d',$time+$parameter->mindelay));
				elseif(!empty($parameter->from)) $where[] = 'dates >= '.$db->Quote($parameter->from);

				if(!empty($parameter->delay)) $where[] = 'dates <= '.$db->Quote(date( 'Y-m-d',$time+$parameter->delay));
				if(!empty($parameter->to)) $where[] = 'enddates <= '.$db->Quote($parameter->to);


				if(!empty($where))
					$query .= ' WHERE ('.implode(') AND (',$where).')';

				if(!empty($parameter->order))
				{
					if($parameter->order == 'rand')
					{
						$query .= ' ORDER BY rand()';
					}else{
						$ordering = explode(',',$parameter->order);
						$query .= ' ORDER BY '.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
					}
				}

				if(!empty($parameter->max_article))
					$query .= ' LIMIT '.intval($parameter->max_article);
				else
					$query .= ' LIMIT 20';
				//We add a limit for the preview otherwise we could break everything

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min_article) && count($allArticles)<$parameter->min_article)
				{
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min_article.' starting after '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles))
				{
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoregistrationpro.php'))
					{
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autoregistrationpro.php');
						$stringTag = ob_get_clean();
					}else{
						$arrayElements = array();
						foreach($allArticles as $oneArticleId)
						{
							$args = array();
							$args[] = 'registrationpro:'.$oneArticleId;
							if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
							if(!empty($parameter->clickable)) $args[] = 'clickable:'.$parameter->clickable;
							if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
							if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							$arrayElements[] = '{'.implode('|',$args).'}';
						}
						$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
					}
				}
				$this->tags[$oneTag] = $stringTag;
			}
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		if(!$this->erp_installed) return '';

		$langregistrationpro = JFactory::getLanguage();
		$langregistrationpro->load('com_registrationpro',JPATH_SITE);

		$db = JFactory::getDBO();
		$db->setQuery('SELECT id, titel FROM #__registrationpro_dates ORDER BY titel ASC');
		$allEvents = (array) $db->loadObjectList();
		$eventList = array();
		foreach($allEvents as $oneEvent)
		{
			$eventList[] = JHTML::_('select.option', $oneEvent->id,$oneEvent->titel);
		}

		$return = '<div id="filter__num__registrationpro">';
		$return .= JText::_('TOTAL_REGISTERED').' '.JHTML::_('select.genericlist', $eventList, 'filter[__num__][registrationpro][id]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '</div>';
		$type['registrationpro'] = 'Event Registration Pro';
		$acyconfig = acymailing_config();
		if(version_compare($acyconfig->get('version'),'4.0.0','<'))
		{
			echo 'Please update AcyMailing, the Event Registration Pro plugin may not work properly with this version';
		}
		return $return;
	}

	function onAcyProcessFilterCount_registrationpro(&$query,$filter,$num){
		$this->onAcyProcessFilter_registrationpro($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_registrationpro(&$query,$filter,$num){
		if(!$this->erp_installed) return;

		$myquery = 'SELECT DISTINCT a.uid FROM #__registrationpro_register as a WHERE a.rdid='.intval($filter['id']);
		$query->db->setQuery($myquery);
		$allUIDs  = acymailing_loadResultArray($query->db);
		if(empty($allUIDs)) $allUIDs[] = 'none';
		$query->where[] = "sub.userid IN ('".implode("','",$allUIDs)."')";
	}
}//endclass