<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingspidercalendar extends JPlugin
{
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->name = 'spidercalendar';
		$this->db = JFactory::getDBO();
		if(!isset($this->params))
		{
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter( $plugin->params );
		}

		//check if the component is installed
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_spidercalendar'))
		{
			$this->component_installed = false;
		}else{
			$this->component_installed = true;
		}
	}

	function acymailing_getPluginType()
	{
		$app = JFactory::getApplication();
		if(!$this->component_installed)
			return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'Spider Calendar';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_spidercalendar_show()
	{
		$config = acymailing_config();

		//We will need the latest developped functions
		if($config->get('version') < '4.7.1'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_'.$this->name,JPATH_SITE);
		$lang->load('com_'.$this->name.'.sys',JPATH_ADMINISTRATOR);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_calendar = $app->getUserStateFromRequest( $paramBase.".filter_calendar", 'filter_calendar','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );
		$pageInfo->autocalendar = $app->getUserStateFromRequest( $paramBase.".autocalendar", 'autocalendar','0','string' );

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id, a.title, b.title AS cattitle, c.title AS calendartitle ' .
				'FROM #__spidercalendar_event AS a ' .
				'LEFT JOIN #__spidercalendar_event_category AS b ON a.category = b.id ' .
				'LEFT JOIN #__spidercalendar_calendar AS c ON a.calendar = c.id ';

		//search fields...
		$searchFields = array('a.id','a.title','b.title','c.title');

		//apply search fields
		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub')
		{
			$filters[] = 'a.published = 1';
		}

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat))
			$filters[] = 'a.category = '.intval($pageInfo->filter_cat);

		//if the user filtered by calendar
		if(!empty($pageInfo->filter_calendar))
			$filters[] = 'a.calendar = '.intval($pageInfo->filter_calendar);

		//apply filters
		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		//apply ordering
		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $this->db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(catid == 'all')
				{
					if(window.document.getElementById('cat'+catid).className == 'selectedrow')
					{
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid])
					{
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if(document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0')
					 {
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0')
					 {
						 otherinfo += '| noreadmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
					 	if(document.adminForm.pict[i].value != '1')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0')
					{
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0')
					 {
						 otherinfo += '| noreadmore';
					 }
				}

				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						if(document.adminForm.autopict[i].value != '1')
							otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value)
				{
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				if(document.adminForm.autocalendar.value != 0)
				{
					otherinfo += "| calendar:"+document.adminForm.autocalendar.value;
				}


				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value)
				{
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value)
				{
					otherinfo += "| order:"+document.adminForm.contentorder.value;
				}

				if(document.adminForm.mindelayevent && document.adminForm.mindelayevent.value && document.adminForm.mindelayevent.value>0){ otherinfo += '| mindelay:'+document.adminForm.mindelayevent.value; }
				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ otherinfo += '| delay:'+document.adminForm.delayevent.value; }
				if(document.adminForm.from_date && document.adminForm.from_date.value){ otherinfo += '| from:'+document.adminForm.from_date.value; }
				if(document.adminForm.to_date && document.adminForm.to_date.value){ otherinfo += '| to:'+document.adminForm.to_date.value; }

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
					if(document.adminForm.min_article.value)
					{
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "date,DESC", JText::_('FIELD_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modified", JText::_('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		if(ACYMAILING_J30)
		{
			$paginationNb = array();
			$paginationNb[] = JHTML::_('select.option', 5,5);
			$paginationNb[] = JHTML::_('select.option', 10,10);
			$paginationNb[] = JHTML::_('select.option', 15,15);
			$paginationNb[] = JHTML::_('select.option', 20,20);
			$paginationNb[] = JHTML::_('select.option', 25,25);
			$paginationNb[] = JHTML::_('select.option', 30,30);
			$paginationNb[] = JHTML::_('select.option', 50,50);
			$paginationNb[] = JHTML::_('select.option', 100,100);
			$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'date', 'label' => 'FIELD_DATE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'time', 'label' => 'TIME', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'category', 'label' => 'SPIDERCALENDAR_EVENT_CATEGORY', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'calendar', 'label' => 'SPIDERCALENDAR_CALENDAR', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'repeated', 'label' => 'REPEAT_EVERY', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'author', 'label' => 'ACY_AUTHOR', 'checked' => '');

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i == 5)
						{
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" width="100%">
				</td>
				<td nowrap="nowrap">
					<?php
						$this->db->setQuery('SELECT id, title FROM #__spidercalendar_calendar ORDER BY title ASC');
						$calendars = $this->db->loadObjectList();
						$calendarvalues = array(JHTML::_('select.option', 0,JText::_('ACY_ALL')));
						if(!empty($calendars))
							foreach($calendars as $oneCalendar)
								$calendarvalues[] = JHTML::_('select.option', $oneCalendar->id, $oneCalendar->title);

						echo JHTML::_('select.genericlist',$calendarvalues, 'filter_calendar', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($pageInfo->filter_calendar));
					?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'SPIDERCALENDAR_CALENDAR' ), 'a.calendar', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					{
						foreach($rows as $row)
						{
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->title))
										{
											echo $row->title;
										}
									?>
								</td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->cattitle))
										{
											echo $row->cattitle;
										}
									?>
								</td>
								<td style="text-align:center;">
									<?php
										if(!empty($row->calendartitle))
										{
											echo $row->calendartitle;
										}
									?>
								</td>
								<td style="text-align:center;">
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php
							echo $pagination->getListFooter();
							if(ACYMAILING_J30)
				 				echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
							echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />

		<?php
			echo $tabs->endPanel();
			// start category tab
			echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i == 5)
						{
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
					<?php echo JText::_('ACY_FROM_DATE'); ?>
				</td>
				<td colspan="2">
				 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('mindelayevent',0,3); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_TO_DATE'); ?>
				</td>
				<td nowrap="nowrap">
				 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('delayevent',7776000,3); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MIN_ARTICLE'); ?>
				</td>
				<td colspan="2">
				 	<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('SPIDERCALENDAR_CALENDAR'); ?>
				</td>
				<td colspan="4">
					<?php
						echo JHTML::_('select.genericlist',$calendarvalues, 'autocalendar', 'style="width:150px;" class="inputbox" size="1" onchange="updateTagAuto();"', 'value', 'text', intval($pageInfo->autocalendar));
					?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td>
					<?php 	echo JText::_('ACY_FROM_DATE'); ?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('calendar', '', 'from_date','from_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto();')); ?>
				</td>
				<td>
					<?php 	echo JText::_('ACY_TO_DATE'); ?>
				</td>
				<td>
					<?php echo JHTML::_('calendar', '', 'to_date','to_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto();')); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('SPIDERCALENDAR_CALENDAR'); ?>
				</td>
				<td>
					<?php
						echo JHTML::_('select.genericlist',$calendarvalues, 'autocalendar', 'style="width:150px;" class="inputbox" size="1" onchange="updateTagAuto();"', 'value', 'text', intval($pageInfo->autocalendar));
					?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php
				$k=0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
						echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
			<?php
				if(!empty($this->catvalues))
				{
					foreach($this->catvalues as $oneCat)
					{
						if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
			<?php
						$k = 1 - $k;
					}
				}
			?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat)
	{
		//select all cats
		$this->db->setQuery('SELECT id, title FROM #__spidercalendar_event_category ORDER BY title ASC');
		$cats = $this->db->loadObjectList();
		$this->catvalues = array(JHTML::_('select.option', 0,JText::_('ACY_ALL')));
		if(!empty($cats))
			foreach($cats as $oneCat)
				$this->catvalues[] = JHTML::_('select.option', $oneCat->id, $oneCat->title);

		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function acymailing_replacetags(&$email)
	{
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	 function _replaceOne(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);

		if(empty($tags)) return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 function _replaceContent(&$tag)
	 {
		$lang = JFactory::getLanguage();
		$lang->load('com_'.$this->name,JPATH_SITE);
		$lang->load('com_'.$this->name.'.sys',JPATH_ADMINISTRATOR);
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$app = JFactory::getApplication();

	 	// extract the fields selected
		if(!empty($tag->display))
		{
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay)
			{
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		// load content
		$query = 'SELECT a.*, b.title AS cattitle, c.title AS calendartitle, d.id AS menuid, u.name ' .
				'FROM #__spidercalendar_event AS a ' .
				'LEFT JOIN #__spidercalendar_event_category AS b ON a.category = b.id ' .
				'LEFT JOIN #__spidercalendar_calendar AS c ON a.calendar = c.id ' .
				'LEFT JOIN #__menu AS d ON (d.link LIKE "index.php?option=com_spidercalendar&view=ajaxbigcalendar" AND d.params LIKE CONCAT(\'%calendar":"\', a.calendar, \'"%\')) ' .
				'LEFT JOIN #__users u ON a.userID = u.id ' .
				'WHERE a.id = '.intval($tag->id).' LIMIT 1';
		$this->db->setQuery($query);
		$content = $this->db->loadObject();

		//In case of we could not load the event for any reason...
		if(empty($content))
		{
			if($app->isAdmin())
			{
				$app->enqueueMessage('The event "'.$tag->id.'" could not be loaded','notice');
			}
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField)
		{
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_spidercalendar&view=spidercalendarbig&calendar_id='.$content->calendar.'&eventID='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		elseif(!empty($content->menuid)) $link .= '&Itemid='.$content->menuid;
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// Include title, main pict and description
		$format = new stdClass();
		$format->tag = $tag;
		$format->title = $content->title;
		$format->description = (!empty($tag->description) && !empty($content->text_for_date)) ? $content->text_for_date : '';
		$format->link = empty($tag->nolink) ? $link : '';
		$format->columns = 2;
		$result .= $acypluginsHelper->getStandardDisplay($format);

		if(!empty($tag->date) && !empty($content->date) && $content->date != '0000-00-00')
		{
			$varFields['{date}'] = acymailing_getDate(strtotime($content->date), JText::_('DATE_FORMAT_LC'));
			$result .= '<tr><td style="width:30%;" valign="top">'.JText::_('DATE').'</td><td>';
			if(!empty($content->date_end) && $content->date_end != '0000-00-00'){
				$varFields['{date_end}'] = acymailing_getDate(strtotime($content->date_end), JText::_('DATE_FORMAT_LC'));
				$result .= $varFields['{date}'].' - '.$varFields['{date_end}'];
			}else{
				$result .= $varFields['{date}'];
			}

			if(!empty($tag->time) && !empty($content->time)){
				$result .= '<br />'.$content->time;
			}
			$result .= '</td></tr>';
		}elseif(!empty($tag->time) && !empty($content->time)){
			$result .= '<tr><td style="width:30%;">'.JText::_('TIME').'</td><td>'.$content->time.'</td></tr>';
		}

		if(!empty($tag->repeated) && $content->repeat_method != 'no_repeat')
		{
			$month_week = array('Mon'=>'Monday','Tue'=>'Tuesday','Wed'=>'Wednesday','Thu'=>'Thursday','Fri'=>'Friday','Sat'=>'Saturday','Sun'=>'Sunday');
			$monthly_list = array(1=>'FIRST',8=>'SECOND',15=>'THIRD',22=>'FOURTH','last'=>'LAST');
			$year_month = array(1=>'January',2=>'February',3=>'March',4=>'April',5=>'May',6=>'June',7=>'July',8=>'August',9=>'September',10=>'October',11=>'November',12=>'December');

			if($content->repeat == 1)
				$repeat = '';
			else
				$repeat = ' '.$content->repeat;

			$result .= '<tr><td colspan="2">';
			if($content->repeat_method == 'daily'){
				$result .= JText::_('REPEAT_EVERY').' '.$repeat.' '.JText::_('DAY');
			}elseif($content->repeat_method == 'weekly'){
				$result .= JText::_('REPEAT_EVERY').' '.$repeat.' '.JText::_('WEEK').' '.trim(str_replace(array_keys($month_week), $month_week, $content->week), ',');
			}elseif($content->repeat_method == 'monthly'){
				if($content->month_type == '2')
				{
					$result .= JText::_('REPEAT_EVERY').' '.$repeat.' '.JText::_('MONTH').' '.JText::_($monthly_list[$content->monthly_list]).' '.$month_week[$content->month_week];
				}else{
					$result .= JText::_('REPEAT_EVERY').' '.$repeat.' '.JText::_('MONTH').' '.$content->month;
				}
			}elseif($content->repeat_method == 'yearly'){
				if($content->month_type == '2')
				{
					$result .= JText::_('REPEAT_EVERY').' '.$repeat.' '.JText::_('YEAR').' '.$year_month[$content->year_month].' '.JText::_('ON_THE').' '.JText::_($monthly_list[$content->monthly_list]).' '.$month_week[$content->month_week];
				}else{
					$result .= JText::_('REPEAT_EVERY').' '.$repeat.' '.JText::_('YEAR').' '.$year_month[$content->year_month].' '.JText::_('ON_THE').' '.$content->month;
				}
			}
			$result .= '</td></tr>';
		}

		// display the calendar
		if(!empty($tag->calendar) && !empty($content->calendartitle))
		{
			$result .= '<tr><td valign="top">'.JText::_('SPIDERCALENDAR_CALENDAR').'</td><td>';
			if(!empty($content->menuid))
				$result .= '<a href="index.php?option=com_spidercalendar&view=ajaxbigcalendar&Itemid='.$content->menuid.'">'.$content->calendartitle.'</a></td></tr>';
			else
				$result .= $content->calendartitle.'</td></tr>';
		}

		// display the category
		if(!empty($tag->category) && !empty($content->cattitle))
		{
			$result .= '<tr><td valign="top">'.JText::_('SPIDERCALENDAR_EVENT_CATEGORY').'</td><td>'.$content->cattitle.'</td></tr>';
		}

		if(!empty($tag->author) && !empty($content->name))
		{
			$result .= '<tr><td valign="top">'.JText::_('ACY_AUTHOR').'</td><td>'.$content->name.'</td></tr>';
		}

		if(empty($tag->noreadmore))
		{
			$varFields['{readmore}'] = '<a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
			$result .= '<tr><td colspan="2" style="padding-top:5px;">'.$varFields['{readmore}'].'</td></tr>';
		}

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	function _replaceAuto(&$email)
	{
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);

			if(!empty($email->altbody))
				$email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);

			foreach($this->tags as $tag => $result)
			{
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$time = time();
		$db = JFactory::getDBO();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;

			if(empty($parameter->from))
				$parameter->from = date( 'Y-m-d H:i:s',$time);

			$allcats = explode('-',$parameter->id);
			//Load the articles based on all arguments...
			$selectedArea = array();

			foreach($allcats as $oneCat)
			{
				if(empty($oneCat)) continue;
				$selectedArea[] = 'a.`category` = '.intval($oneCat);
			}

			$query = 'SELECT a.id FROM `#__spidercalendar_event` as a ';

			if(isset($parameter->priority))
			{
				$query .= ' JOIN `#__jevents_vevdetail` as evdet ON ev.detail_id = evdet.evdet_id ';
			}
			$where = array();
			if(!empty($selectedArea))
			{
				$where[] = implode(' OR ',$selectedArea);
			}

			$where[] = 'a.`published` = 1';

			if(!empty($parameter->addcurrent))
			{
				//not finished and next events
				$where[] = 'a.`date_end` LIKE "0000-00-00" OR a.`date_end` >= '.$db->Quote($parameter->from);
			}else{
				//not started events
				$where[] = 'a.`date` >= '.$db->Quote($parameter->from);
			}

			//should we display only events starting in the sending day ?
			if(!empty($parameter->todaysevent))
			{
				$where[] = 'a.`date` <= '.$db->Quote(date('Y-m-d 23:59:59', $time));
			}

			if(!empty($parameter->mindelay)) $where[] = 'a.`date` >= '.$db->Quote(date('Y-m-d H:i:s', $time+$parameter->mindelay));
			if(!empty($parameter->delay)) $where[] = 'a.`date` <= '.$db->Quote(date('Y-m-d H:i:s', $time+$parameter->delay));
			if(!empty($parameter->to)) $where[] = 'a.`date` <= '.$db->Quote($parameter->to);

			$query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order))
			{
				if($parameter->order == 'rand')
				{
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max))
				$query .= ' LIMIT '.intval($parameter->max);
			else
				$query .= ' LIMIT 20';

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			if(!empty($parameter->min) && count($allArticles) < $parameter->min)
			{
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}
			$stringTag = '';
			if(!empty($allArticles))
			{
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>