<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingTagjcalpro extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params))
		{
			$plugin = JPluginHelper::getPlugin('acymailing', 'tagjcalpro');
			$this->params = new JParameter( $plugin->params );
		}

		if(!ACYMAILING_J16){
			$this->eventid = 'extid';
			$this->table = 'jcalpro2';
			$this->table_categories = 'jcalpro2';
			$this->cat_id = 'cat_id';
			$this->name = 'cat_name';
		}else{
			$this->eventid = 'id';
			$this->table = 'jcalpro';
			$this->table_categories = 'jcalpro_event';
			$this->cat_id = 'category_id';
			$this->name = 'title';
		}
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = JText::_('JOOMEXT_EVENT'). ' <small>(jCalPro)</small>';
	 	$onePlugin->function = 'acymailingtagjcalpro_show';
	 	$onePlugin->help = 'plugin-tagjcalpro';

	 	return $onePlugin;
	}

	function acymailingtagjcalpro_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.tagjcalpro';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'a.'.$this->eventid,'cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight',150,'string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth',150,'string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->autoreadmore = $app->getUserStateFromRequest( $paramBase.".autoreadmore", 'autoreadmore','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','| cols:1','string' );
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','| order:id,DESC','string' );

		$db = JFactory::getDBO();
		$filters = array();
		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search).'%\'';
			$filters[] = $this->eventid." LIKE $searchVal OR title LIKE $searchVal OR description LIKE $searchVal";
		}

		if($this->params->get('hidepastevents','yes') == 'yes')
		{
			$filters[] = "`start_date` >= ".$db->Quote(date('Y-m-d',time() - 86400));
		}

		if(!empty($pageInfo->filter_cat))
		{
			if(ACYMAILING_J16)
				$filters[] = "b.category_id = ".$pageInfo->filter_cat;
			else
				$filters[] = "a.cat = ".$pageInfo->filter_cat;
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, a.'.$this->eventid.' as id, a.title, a.description, a.start_date FROM '.acymailing_table($this->table.'_events',false).' AS a ';
		if(ACYMAILING_J16)
		{
			$query .= 'JOIN '.acymailing_table($this->table_categories.'_categories',false).' AS b ON a.id = b.event_id ';
		}
		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}
		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();
		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$picts = array();
		$picts[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$picts[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "| order:id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "| order:start_date,DESC",JText::_('FIELD_DATE'));
		$ordering[] = JHTML::_('select.option', "| order:created,DESC",JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "| order:title,ASC",JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "| order:rand",JText::_('ACY_RANDOM'));

		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "| cols:$i",$i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'jcalpro_tab');
		echo $tabs->startPanel( JText::_( 'JOOMEXT_EVENT' ), 'jcalpro_event');
	?>
	<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyEvent(eventid,rowClass)
			{
				if(selectedContents[eventid])
				{
					window.document.getElementById('content'+eventid).className = rowClass;
					delete selectedContents[eventid];
				}else{
					window.document.getElementById('content'+eventid).className = 'selectedrow';
					selectedContents[eventid] = 'content';
				}
				updateEventTag();
			}

			function updateEventTag()
			{
				var tag = '';
				var otherinfo = '';

				var tmp=0;
				for(var i=0 ; i<document.adminForm.cbaffiche.length; i++)
				{
					if(document.adminForm.cbaffiche[i].checked)
					{
						if(tmp==0)
						{
							tmp=1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbaffiche[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbaffiche[i].value;
						}
					}
				}

				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if (document.adminForm.clickable[i].checked){ otherinfo += "| clickable:"+document.adminForm.clickable[i].value;}
				}

				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked)
					 {
					 	otherinfo += "| readmore:"+document.adminForm.readmore[i].value;
					 }
				}

				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					 if (document.adminForm.pict[i].checked)
					 {
					 	otherinfo += '| pict:'+document.adminForm.pict[i].value;
						if(document.adminForm.pict[i].value == 'resized')
						{
					 		document.getElementById('pictsize').style.display = '';
					 		if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
					 		if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
					 	}else{
					 		document.getElementById('pictsize').style.display = 'none';
					 	}
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				for(var i in selectedContents)
				{
					if(selectedContents[i] == 'content')
					{
						tag = tag + '{jcalpro:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}
		//-->
	</script>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td><input type="checkbox" name="cbaffiche" value="title" id="title" checked="checked" onclick="updateEventTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="description" id="description" onclick="updateEventTag();"/><label style="margin-left:5px" for="description" id="description-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="date" id="date" onclick="updateEventTag();"/><label style="margin-left:5px" for="date" id="date-lbl"><?php echo JText::_('FIELD_DATE');?></label></td>
				<td><input type="checkbox" name="cbaffiche" value="address" id="address" onclick="updateEventTag();"/><label style="margin-left:5px" for="address" id="address-lbl"><?php echo JText::_('ADDRESSCAPTION');?></label></td>
			</tr>
			<tr>
				<td><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="4"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
			</tr>
			<tr>
				<td>Truncate the description after :</td> <?php/*TODO : the jtext doesn't exist*/?>
				<td colspan="4"><input type="text" name="wrap" style="width:50px" value="0" onchange="updateEventTag();"/> characters</td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td colspan="4"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td valign="top" colspan="4"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pict' , 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateEventTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateEventTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_DESCRIPTION'), 'a.description', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_DATE'), 'a.start_date', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.'.$this->eventid, $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="10">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					foreach($rows as $row)
					{
				?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyEvent(<?php echo $row->id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"/>
						<td nowrap="nowrap">
						<?php
							echo $row->title;
						?>
						</td>
						<td>
						<?php
							$newintrotext = $row->description;
							$newintrotext = strip_tags($newintrotext,'<br>');
							$numChar = strlen($newintrotext);
							if($numChar > 120)
							{
								$stop = strlen($newintrotext);
								for($i=120;$i<$numChar;$i++)
								{
									if($newintrotext[$i] == " ")
									{
										$stop = $i;
										break;
									}
								}
								$newintrotext = substr($newintrotext,0,$stop).'...';
							}
							echo acymailing_absoluteURL($newintrotext);
						?>
						</td>
						<td nowrap="nowrap">
							<?php
							if(ACYMAILING_J16)
							{
								$date = new JDate($row->start_date);
								$date->setTimezone(new DateTimeZone($row->timezone));
								$function = ACYMAILING_J30 ? 'format' : 'toFormat';
								echo $date->$function(JText::_('DATE_FORMAT_LC'), true);
							}else{
								echo JHTML::_('date',strtotime($row->start_date),JText::_('DATE_FORMAT_LC'));
							}
							 ?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_( 'UPCOMING_EVENTS' ), 'jcalpro_auto');

		$type = JRequest::getString('type');

		if(!ACYMAILING_J16)
		{
			$db->setQuery('SELECT cat_name as name, cat_id FROM `#__jcalpro2_categories` ');
		}else{
			$db->setQuery('SELECT title as name, id as cat_id  FROM `#__categories` WHERE extension like "com_jcalpro" ORDER BY lft ASC');
		}
		$categories = $db->loadObjectList();


		?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
			<!--
				var selectedCat = new Array();
				function applyAutoEvent(catid,rowClass)
				{
					if(selectedCat[catid])
					{
						window.document.getElementById('event_cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('event_cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'event';
					}
					updateTag();
				}

				function updateTag()
				{
					var tag = '';
					var otherinfo = '';
					var tmp=0;
					for(var i=0; i < document.adminForm.cbafficheauto.length; i++)
					{
						if(document.adminForm.cbafficheauto[i].checked)
						{
							if(tmp==0)
							{
								tmp+=1;
								otherinfo += "| display:";
								otherinfo += document.adminForm.cbafficheauto[i].value;
							}else{
								otherinfo += ", ";
								otherinfo += document.adminForm.cbafficheauto[i].value;
							}
						}
					}
					for(var i=0; i < document.adminForm.clickableauto.length; i++)
					{
						 if (document.adminForm.clickableauto[i].checked)
						 {
						 	otherinfo += "| clickable:"+document.adminForm.clickableauto[i].value;
						 }
					}
					tmp=0;
					for(var i=0 ; i<document.adminForm.autopict.length ; i++)
					{
						 if (document.adminForm.autopict[i].checked)
						 {
						 	otherinfo += '| pict:'+document.adminForm.autopict[i].value;
							if(document.adminForm.autopict[i].value == 'resized')
							{
						 		document.getElementById('pictsizeauto').style.display = '';
						 		if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
						 		if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						 	}else{
						 		document.getElementById('pictsizeauto').style.display = 'none';
						 	}
						 }
					}

					for(var i=0; i < document.adminForm.autoreadmore.length; i++)
					{
						 if(document.adminForm.autoreadmore[i].checked)
						 {
						 	otherinfo += "| readmore:"+document.adminForm.autoreadmore[i].value;
						 }
					}

					if(document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ otherinfo += '| delay:'+document.adminForm.delayevent.value; }

					if(document.adminForm.autowrap.value && document.adminForm.autowrap.value!=0)
					{
						otherinfo += "| wrap:"+document.adminForm.autowrap.value;
					}

					if(document.adminForm.max_article.value){ otherinfo += "| max_article:"+document.adminForm.max_article.value; }
					if(document.adminForm.cols.value){ otherinfo += document.adminForm.cols.value; }
					if(document.adminForm.contentorder.value){ otherinfo += document.adminForm.contentorder.value; }
					<?php if($type == 'autonews'){ ?>
					if(document.adminForm.min_article.value){ otherinfo += "| min_article:"+document.adminForm.min_article.value; }
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ otherinfo += document.adminForm.contentfilter.value; }
					<?php } ?>
					tag = '{autojcalpro:';
					for(var icat in selectedCat)
					{
						if(selectedCat[icat] == 'event')
						{
							tag += icat+'-';
						}
					}
					tag+=otherinfo+'}<br />';
					setTag(tag);
				}
			//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td><input type="checkbox" name="cbafficheauto" value="title" id="titleauto" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td><input type="checkbox" name="cbafficheauto" value="description" id="descriptionauto" onclick="updateTag();"/><label style="margin-left:5px" for="descriptionauto" id="descriptionauto-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<th align="center"><div><input type="checkbox" name="cbafficheauto" value="date" id="dateauto" onclick="updateTag();"/><label style="margin-left:5px" for="dateauto" id="dateauto-lbl"><?php echo JText::_('FIELD_DATE');?></label></div></th>
				<td><input type="checkbox" name="cbafficheauto" value="address" id="addressauto" onclick="updateTag();"/><label style="margin-left:5px" for="addressauto" id="addressauto-lbl"><?php echo JText::_('ADDRESSCAPTION');?></label></td>
			</tr>
			<tr>
				<td><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="4"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap">Truncate the description after :</td> <?php/*TODO : the jtext doesn't exist*/?>
				<td colspan="4"><input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTag();"/> characters</td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td colspan="4"><?php echo JHTML::_('acyselect.radiolist', $choice, 'autoreadmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->autoreadmore); ?></td>
			</tr>
			<tr>
				<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="4" valign="top"><?php echo JHTML::_('acyselect.radiolist', $picts, 'autopict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->autopict); ?>
				<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td colspan="2">
				 	<input type="text" class="inputbox" name="max_article" style="width:50px" value="20" onchange="updateTag();"/>
				</td>
				<td>
					<?php echo JText::_('MAX_STARTING_DATE'); ?>
				</td>
				<td>
				 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTag();"; echo $delayType->display('delayevent',7776000,3); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td>
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" style="width:60px" onchange="updateTag();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
				<td/>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" style="width:150px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
			<tr>
				<td>
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td>
				<td colspan="4">
					<input type="text" class="inputbox" name="min_article" style="width:50px" value="1" onchange="updateTag();"/>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0; if(!empty($categories))foreach($categories as $oneCat){ ?>
			<tr id="event_cat<?php echo $oneCat->cat_id ?>" class="<?php echo "row$k"; ?>" onclick="applyAutoEvent(<?php echo $oneCat->cat_id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"/>
				<td>
				<?php
					echo $oneCat->name;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();

	//End of the function
	}

	function _categories($filter_cat){
		if(!ACYMAILING_J16) return '';
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id,parent_id,title,extension FROM #__categories ORDER BY `id` DESC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats))
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=0,$level=0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			if($cat->extension == "com_jcalpro") $this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email,$send = true){
	 	$this->_replaceAuto($email);
	 	$this->_replaceEvents($email);
	}

	private function _replaceEvents(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'jcalpro');
		if(empty($tags)) return;

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceEvent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceEvent($tag){
		if(empty($tag->display)) $tag->display = 'title,description,date';

		$tag->display = explode(',',str_replace(' ','',strip_tags($tag->display)));

		//1 : Load the informations of the product...
		if(!empty($tag->display) && in_array('address', $tag->display)){
			$query = 'SELECT a.*, a.'.$this->eventid.' AS id, b.title AS loctitle, b.id AS locid FROM '.acymailing_table($this->table.'_events',false).' AS a ';
			$query .= 'JOIN '.acymailing_table($this->table.'_locations',false).' AS b ON a.location = b.id ';
		}else{
			$query = 'SELECT a.*, '.$this->eventid.' AS id FROM '.acymailing_table($this->table.'_events',false).' AS a ';
		}
		$query .= 'WHERE a.'.$this->eventid.' = '.intval($tag->id).' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$row = $db->loadObject();

		$result = '';
		if(empty($row)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The event "'.$tag->id.'" could not be loaded','notice');
			return $result;
		}

		$link = acymailing_frontendLink('index.php?option=com_jcalpro&view=event&id='.intval($tag->id));

		$result = '<table cellspacing="0" cellpadding="0" border="0" width="100%">';
		if(!empty($tag->display) && in_array('title',$tag->display))
		{
			if(!empty($tag->clickable))
			{
				$result .= '<tr><td><a target="_blank" href="'.$link.'"><h2 class="acymailing_title">'.$row->title.'</h2></a></td></tr>';
			}else{
				$result .= '<tr><td><h2 class="acymailing_title">'.$row->title.'</h2></td></tr>';
			}
		}

		if(!empty($tag->display) && in_array('description',$tag->display)){
			$result .= '<tr><td>'.$this->acypluginsHelper->wrapText($row->description, $tag).'</td></tr>';
		}

		if(!empty($tag->display) && in_array('address',$tag->display)){
			$linklocation = acymailing_frontendLink('index.php?option=com_jcalpro&view=location&id='.$row->locid);
			$result .= '<tr><td><a target="_blank" href="'.$linklocation.'">'.$row->loctitle.'</a></td></tr>';
		}

		if(!empty($tag->display) && in_array('date',$tag->display)){
			if(ACYMAILING_J16){
				$date = new JDate($row->start_date);
				$date->setTimezone(new DateTimeZone($row->timezone));
				$function = ACYMAILING_J30 ? 'format' : 'toFormat';
				$date = $date->$function(JText::_('DATE_FORMAT_LC'), true);
				if(!empty($row->end_date)){
					$endate = new JDate($row->end_date);
					$endate->setTimezone(new DateTimeZone($row->timezone));
					$endate = $endate->$function(JText::_('DATE_FORMAT_LC'), true);
					$date .= ' - '.$endate;
				}
			}else{
				$time = strtotime($row->start_date);
				$date = JHTML::_('date',$time,JText::_('DATE_FORMAT_LC'));
				if(!empty($row->end_date))
				{
					$time = strtotime($row->end_date);
					$endate = JHTML::_('date',$time,JText::_('DATE_FORMAT_LC'));
					$date .= ' - '.$endate;
				}
			}
			$result .= '<tr><td><span class="eventdate">'.$date.'</span></td></tr>';
		}

		if(!empty($tag->readmore)){
			$readMoreText = empty($this->readmore) ? JText::_('JOOMEXT_READ_MORE') : $this->readmore;
			$result .= '<tr><td><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a></td></tr>';
		}

		$result = '<div class="acymailing_content" >'.$result.'</table></div>';

		//Check if the template exists...
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'tagjcalpro.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'tagjcalpro.php');
			return ob_get_clean();
		}

		$result = $this->acypluginsHelper->removeJS($result);
		if(isset($tag->pict) && $tag->pict == 1) $result = str_replace('\\','/',$result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email,'autojcalpro');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		$db = JFactory::getDBO();
		$time = time();

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;

				if(!ACYMAILING_J16) $selectedArea[] = 'a.`cat` = '.intval($oneCat);
				else $selectedArea[] = 'c.`category_id` = '.intval($oneCat);
			}

			if(!ACYMAILING_J16) $query = 'SELECT a.`'.$this->eventid.'` FROM `#__jcalpro2_events` as a';
			else $query = 'SELECT a.`id` FROM `#__jcalpro_events` as a LEFT JOIN `#__jcalpro_event_categories` as c ON a.`id`=c.`event_id`';

			$where = array();
			if(!empty($selectedArea)) $where[] = implode(' OR ',$selectedArea);

			$where[] = 'a.`published` = 1';
			$where[] = 'a.`approved` = 1';
			$where[] = 'a.`start_date` >= '.$db->Quote(date( 'Y-m-d H:i:s',$time));
			if(!empty($parameter->delay)) $where[] = 'a.`start_date` <= '.$db->Quote(date( 'Y-m-d H:i:s',$time + $parameter->delay));
			if($this->params->get('contentaccess','public') == 'public') $where[] = 'a.`private` != 1';

			$query .= ' WHERE ('.implode(') AND (',$where).')';

			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY `'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
				}
			}
			if(!empty($parameter->max_article)) $query .= ' LIMIT '.intval($parameter->max_article);
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			if(!empty($parameter->min_article) && count($allArticles) < $parameter->min_article){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min_article;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autojcalpro.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autojcalpro.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$arrayElements = array();
					$numArticle = 1;
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'jcalpro:'.$oneArticleId;
						$args[] = 'num:'.$numArticle++;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->clickable)) $args[] = 'clickable:'.$parameter->clickable;
						if(isset($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass