<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SARL - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingTagrsevent extends JPlugin
{

	var $searchFields = array('e.EventDescription','e.EventName');

	function plgAcymailingTagrsevents(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'tagrsevent');
			$this->params = new JParameter( $plugin->params );
		}
	}

	 function acymailing_getPluginType() {

	 	$onePlugin = new stdClass();
	 	$onePlugin->name = JText::_('JOOMEXT_EVENT'). ' <small>(RsEvents)</small>';
	 	$onePlugin->function = 'acymailingtagrsevent_show';
	 	$onePlugin->help = 'plugin-tagrsevent';

	 	return $onePlugin;
	 }

	 function acymailingtagrsevent_show(){
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.tagrsevent';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'e.IdEvent ','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';

		$pageInfo->author = $app->getUserStateFromRequest( $paramBase.".author", 'author','','string' );
		$pageInfo->link = $app->getUserStateFromRequest( $paramBase.".link", 'link','|link','string' );
		$pageInfo->place = $app->getUserStateFromRequest( $paramBase.".place", 'place','|place','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','|pict:1','string' );
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','|type:full','string' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','|type:full','string' );
		$pageInfo->autolink = $app->getUserStateFromRequest( $paramBase.".autolink", 'autolink','|link','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','|pict:1','string' );

		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		if(!empty($pageInfo->filter_cat)) $filters[] = "c.IdCategory = ".$pageInfo->filter_cat;

		$db = JFactory::getDBO();
		$pictureHelper = acymailing_get('helper.acypict');
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$this->searchFields)." LIKE $searchVal";
		}

		//we hide past events but we remove one day just to make sure we won't hide something we should not!
		if($this->params->get('hidepastevents','yes') == 'yes'){
			$filters[] = 'e.EventStartDate >= '.$db->Quote(time() - 86400);
		}

		$whereQuery = '';
		if(!empty($filters)){
			$whereQuery = ' WHERE ('.implode(') AND (',$filters).')';
		}

		$query = 'SELECT DISTINCT SQL_CALC_FOUND_ROWS e.IdEvent as id, e.IdLocation as loc, e.IdUser as iduser, e.EventDescription as descri, ';
		$query .= 'e.EventStartDate as start, e.EventEndDate as end, e.EventName as title ';
		$query .= 'FROM `#__rsevents_events` AS e ';
		$query .= 'JOIN `#__users` AS u ON e.iduser = u.id ';
		$query .= 'JOIN `#__rsevents_locations` AS location ON e.IdLocation=location.IdLocation ';
		$query .= 'JOIN `#__rsevents_events_cat` AS ce ON ce.IdEvent = e.IdEvent ';
		$query .= 'JOIN `#__rsevents_categories` AS c ON c.IdCategory=ce.IdCategory ';

		if(!empty($whereQuery)) $query.= $whereQuery;
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'rsevents_tab');
		echo $tabs->startPanel( JText::_( 'JOOMEXT_EVENT' ), 'rsevents_event');

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "|pict:1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "|pict:resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "|pict:0",JText::_('JOOMEXT_NO'));



	?>
		<br style="font-size:1px"/>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td>
				</td>
				<td>
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php
					$listtheme = $this->_theme();
					echo JText::_('ACY_THEME').' '.JHTML::_('select.genericlist', $listtheme, "theme", " onchange=updateTag(); ", "value", "text");
					?>
				</td>
				<td colspan="2" nowrap="nowrap">
					<?php echo JText::_('DISPLAY_PICTURES');
					echo JHTML::_('select.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict);?>
				</td>
				<td>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'e.EventName', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_DESCRIPTION'), 'e.EventDescription ', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('FIELD_DATE'), 'e.EventStartDate', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'e.IdEvent', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
						<td width="150px">
						<?php echo $row->title; ?>
						</td>
						<td width="300px">
						<?php
						 		echo substr(strip_tags($row->descri),0,120).'...';
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo JHTML::_('date',  $row->start, JText::_('DATE_FORMAT_LC') ); ?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php
	echo $tabs->endPanel();
	echo $tabs->startPanel( JText::_( 'UPCOMING_EVENTS' ), 'rsevent_auto');
	$type = JRequest::getString('type');

	$db->setQuery('SELECT a.* FROM `#__rsevents_categories` as a order by ordering');
	$categories = $db->loadObjectList('IdCategory');

	?>
	<br style="font-size:1px"/>
	<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				if(document.getElementById('theme') && document.getElementById('theme').options[document.getElementById('theme').selectedIndex].value ){
					otherinfo = '|theme:'+document.getElementById('theme').options[document.getElementById('theme').selectedIndex].value;
				}
				for(var i=0; i < document.adminForm.pict.length; i++){
						 if (document.adminForm.pict[i].checked){ otherinfo += document.adminForm.pict[i].value; }
				}
				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{rsevent:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateTagAuto();
			}

			function updateTagAuto(){
				tag = '{autorsevent:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				for(var i=0; i < document.adminForm.autopict.length; i++){
					if (document.adminForm.autopict[i].checked){ tag += document.adminForm.autopict[i].value; }
				}
				if(document.getElementById('theme2') && document.getElementById('theme2').options[document.getElementById('theme2').selectedIndex].value && document.getElementById('theme2').options[document.getElementById('theme2').selectedIndex].value!=0 ){
					tag += '|theme:'+document.getElementById('theme2').options[document.getElementById('theme2').selectedIndex].value;
				}
				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				if(document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ tag += '|delay:'+document.adminForm.delayevent.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
	<table width="100%" class="adminform">
		<tr>
			<td>
				<?php echo JText::_('MAX_ARTICLE'); ?>
			 </td>
			 <td>
				<input type="text" name="max_article" style="width:50px" value="" onchange="updateTagAuto();"/>
			</td>
			<td>
				<?php echo JText::_('MAX_STARTING_DATE'); $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('delayevent',7776000,3); ?>
			 </td>
		</tr>

		<tr>
		<?php if($type == 'autonews') { ?>
			<td>
			<?php 	echo JText::_('MIN_ARTICLE'); ?>
			 </td>
			 <td>
				<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
			</td>
		<?php } ?>
			<td>
				<?php echo JText::_('ACY_THEME').' '.JHTML::_('select.genericlist', $listtheme, "theme2", " onchange=updateTagAuto(); ", "value", "text");
				?>
			</td>
		</tr>
		<tr>
			<td>
				<?php echo JText::_('DISPLAY_PICTURES');
				echo JHTML::_('select.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict);?>
			</td>
		</tr>

	</table>
	<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
	<?php $k=0; foreach($categories as $oneCat){ ?>
		<tr id="cat<?php echo $oneCat->IdCategory ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->IdCategory ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
			<td>
			<?php
				echo $oneCat->CategoryName;
			?>
			</td>
		</tr>
	<?php $k = 1 - $k; } ?>
	</table>
	<?php
	echo $tabs->endPanel();
	echo $tabs->endPane();

	//End of the function
	 }


	 function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM '.acymailing_table('rsevents_categories',false).' ORDER BY `ordering` ASC');
		$mosetCats = $db->loadRowList();

		$catvalues = array();
			$catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		while(list($key,$val)=each($mosetCats))
		{
			$catvalues[] = JHTML::_('select.option', $val[0],JText::_( $val[2] ));
		}
		return JHTML::_('select.genericlist', $catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text');

	}

	function _theme(){
		$valtheme = array();

		$query = 'SELECT * FROM #__rsevents_themes';
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$theme =  $db->loadRowList();

		$listtheme = array();
		$listtheme[] = JHTML::_('select.option', 0, 'Acymailing');
		while ( list( $key, $val )= each($theme) )
		{
			$listtheme[] = JHTML::_('select.option', $val[0], JText::_( $val[1] ) );
		}

		return $listtheme;
	}

	 function acymailing_replacetags(&$email){

	 	$this->_replaceAuto($email);
	 	$this->_replaceEvents($email);
	 }

	 function _replaceEvents(&$email){
		$match = '#{rsevent:(.*)}#Ui';
		$variables = array('body','altbody','subject');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		$mailerHelper = acymailing_get('helper.mailer');
		include_once(ACYMAILING_ROOT.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'theme.php');
		include_once(ACYMAILING_ROOT.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		include_once(ACYMAILING_ROOT.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'events.php');

		$lang = JFactory::getLanguage();
		$lang->load('com_rsevents',JPATH_SITE);

		$config = rseventsHelper::readConfig();

		$resultshtml = array();
		$resultstext = array();
		$resultssubject = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($resultshtml[$oneTag])) continue;

				$resultshtml[$oneTag] = $this->_replaceEvent($allresults[1][$i]);
				$resultstext[$oneTag] = $mailerHelper->textVersion($resultshtml[$oneTag]);
				$resultssubject[$oneTag] = trim(strip_tags($resultstext[$oneTag]));
			}
		}

		$email->body = str_replace(array_keys($resultshtml),$resultshtml,$email->body);
		$email->altbody = str_replace(array_keys($resultstext),$resultstext,$email->altbody);
		$email->subject = str_replace(array_keys($resultssubject),$resultssubject,$email->subject);
	 }

	 function _replaceEvent($id){
		$arguments = explode('|',strip_tags($id));
		$tag = new stdClass();
		$tag->id = (int) $arguments[0];
		for($i=1,$a=count($arguments);$i<$a;$i++){
			$args = explode(':',$arguments[$i]);
			if(isset($args[1])){
				$tag->$args[0] = $args[1];
			}else{
				$tag->$args[0] = true;
			}
		}
		$query2 = 'SELECT e.*, l.IdLocation, l.LocationName, l.LocationDescription, l.LocationAlias, l.LocationURL, l.LocationCity, l.LocationAddress, l.LocationZip, l.LocationState, l.LocationCountry, l.LocationLat, l.LocationLon ,f.FileName, f.FileLocation , u.username AS EventOwner ';
		$query2 .= 'FROM #__rsevents_events e ';
		$query2 .= 'LEFT JOIN #__rsevents_locations l ';
		$query2 .= 'ON e.IdLocation = l.IdLocation ';
		$query2 .= 'LEFT JOIN #__rsevents_events_cat ec ';
		$query2 .= 'ON ec.IdEvent = e.IdEvent ';
		$query2 .= 'LEFT JOIN #__rsevents_categories c ';
		$query2 .= 'ON c.IdCategory = ec.IdCategory ';
		$query2 .= 'LEFT JOIN #__users u ';
		$query2 .= 'ON e.IdUser = u.id ';
		$query2 .= 'LEFT JOIN #__rsevents_files f ';
		$query2 .= 'ON f.IdEvent=e.IdEvent ';
		$query2 .= 'WHERE e.IdEvent='.intval($tag->id).' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query2);
		$event = $db->loadObject();

		$app = JFactory::getApplication();
		if(empty($event)){
			if($app->isAdmin()){
				$app->enqueueMessage('The RsEvent content "'.$tag->id.'" could not be loaded','notice');
			}
			return '';
		}


		if(!empty($tag->theme)){
			$theme = new RseventsTheme($tag->theme,$event);
			$result = $theme->render();
		}
		else{
			$result = '';
			$linkLoc = 'index.php?option=com_rsevents&view=locations&layout=show&cid='.$event->IdLocation.'&IdEvent='.$tag->id;
			$linkLoc = acymailing_frontendLink($linkLoc);

			$config = rseventsHelper::getConfig();

			$link = 'index.php?option=com_rsevents&view=events&layout=show&cid='.$tag->id;
			$link = acymailing_frontendLink($link);

			$title = '<div class="acymailing_content" >';
			$title .= '<a target="_blank" href='.$link.' ><h2 class="acymailing_title">'.$event->EventName.' </h2></a>';
			$place = JText::_('RSE_AT_LOCATION').': <a href='.$linkLoc.' target="_blank">'.$event->LocationName.'</a><br />';
			$hosted = JText::_('RSE_HOSTED_BY').' '.$event->EventHost.'<br />';
			$start = JText::_('RSE_START_EVENT').' '.rseventsHelper::translateDate(date($config['global.dateformat'],$event->EventStartDate)).'<br />';
			$end = JText::_('RSE_END_EVENT').' '.rseventsHelper::translateDate(date($config['global.dateformat'],$event->EventEndDate)).'<br />';
			$posted = JText::_('RSE_EVENT_POSTED').' '.$event->EventOwner.'<br />';

			$descri = $event->EventDescription.'</div>';

			$result = $title.$place.$hosted.$start.$end.$posted.$descri;

			if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'tagrsevent.php')){
				ob_start();
				require(ACYMAILING_MEDIA.'plugins'.DS.'tagrsevent.php');
				return ob_get_clean();
			}

		}
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();
		//Check if we should generate the autoNewsletter or not...
		$match = '#{autorsevent:(.*)}#Ui';
		$variables = array('body','altbody','subject');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|',$allresults[1][$i]);
				//The first argument is a list of sections and cats...
				$allcats = explode('-',$arguments[0]);
				$parameter = null;
				for($i=1;$i<count($arguments);$i++){
					$args = explode(':',$arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = 'ec.`IdCategory` = '.(int) $oneCat;
				}

				$query = 'SELECT DISTINCT e.IdEvent ';
				$query .= 'FROM #__rsevents_events e ';
				$query .= 'JOIN #__rsevents_events_cat ec ';
				$query .= 'ON ec.IdEvent = e.IdEvent ';

				$where = array();
				if(!empty($selectedArea)){
					$where[] = implode(' OR ',$selectedArea);
				}

				$where[] = 'e.`published` = 1';
				$where[] = 'e.`EventStartDate` >= '.$time;
				if(!empty($parameter->delay)) $where[] = 'e.`EventStartDate` <= '.$time+$parameter->delay;

				$query .= ' WHERE ('.implode(') AND (',$where).')';
				$query .= ' ORDER BY e.`EventStartDate` ASC';
				if(!empty($parameter->max)) $query .= ' LIMIT '.(int) $parameter->max;

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) AND count($allArticles)< $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autorsevents.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autorsevents.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$stringTag .= '<table cellspacing="0" cellpadding="0" border="0" >';
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'rsevent:'.$oneArticleId;
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->theme)) $args[] = 'theme:'.$parameter->theme;
							$stringTag .= '{'.implode('|',$args).'}';
							$stringTag .= '</td></tr>';
						}
						$stringTag .= '</table>';
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}
}//endclass